#!/usr/bin/perl

$interface = "0.0.0.0";
$port = "10001";
$commport = "/dev/cuaa4";


#################################################################################

use Socket;
use Fcntl;
use FileHandle;


open(COMMIN, "$commport") || die "Cannot open $commport";
open(COMMOUT, ">$commport") || die "Cannot open $commport";
COMMOUT->autoflush(1);

socket(SERVER, PF_INET, SOCK_STREAM, getprotobyname('tcp') )  || die "socket: $!";

setsockopt(SERVER, SOL_SOCKET, SO_REUSEADDR, 1) || die "setsockopt: $!";

bind(SERVER, sockaddr_in($port, inet_aton($interface))) || die "bind: $!";

listen(SERVER,$max_conn) || die "listen: $!";


while( 1 ) {
	$rin = '';

	vec($rin, fileno(SERVER), 1) = 1;
	vec($rin, fileno(COMMIN), 1) = 1;

	foreach (values %clients) {
		vec($rin, $_, 1) = 1;
	}

	$s = select($rout = $rin, undef, $eout = $rin, 1);

	next if($s <= 0);

	if(vec($eout, fileno(COMMIN), 1)) {
		print "*** Comm port accidently closed!\n";
		exit;
	}

	if(vec($eout, fileno(SERVER), 1)) {
		print "*** Server socket accidently died!\n";
		exit;
	}

	foreach $client (keys %clients) {
		if(vec($eout, $clients{$client}, 1)) {
			print "*** Client $client (fd = $clients{$client}) disconnected!\n";
			close($client);
			delete $clients{$client};
		}
	}

	if(vec($rout, fileno(COMMIN), 1)) {
		if($rc = sysread(COMMIN, $buf, 1024) > 0) {
			print "$buf";
			foreach $client (keys %clients) { print $client $buf; }
		}
	}


	if(vec($rout, fileno(SERVER), 1)) {
                # new connection
                my $new_client = genfilehandle();

                my $paddr = accept($new_client, SERVER);
                my($port,$iaddr) = sockaddr_in($paddr);
                my $name = gethostbyaddr($iaddr,AF_INET);

                print "Connection from $name [", inet_ntoa($iaddr), "] at port $port, fd = ".fileno($new_client)."\n";
		print $new_client "HELLO\n";

		fcntl($new_client, &F_SETFL, O_NONBLOCK);
		$new_client->autoflush(1);
                $clients{$new_client} = fileno($new_client); 
	}

	foreach $client (keys %clients) {
		if(vec($rout, $clients{$client}, 1)) {
			$rc = sysread($client, $buf, 1024);
			if($rc <= 0) {
				print "*** Client $client (fd = $clients{$client}) disconnected!\n";
				close($client);
				delete $clients{$client};
				next;
			}
			print "$clients{$client}:	".$buf;
			print COMMOUT $buf;
		}
	}

}



sub genfilehandle {
	return "SOCKET:".time.":".int(rand(100));
}

