###############################################
# Eugeni Korolenko, November 2003
# Ruslan Zalata, November 2003
###############################################
#
#

proc init {} {
	global format_destination
	global voice_message
	global welcomed
	global dir_prefix
	global dest

	set dest ""
	set format_destination(interruptPrompt) true
	set format_destination(maxDigits) 32 
	set format_destination(terminationKey) #
	set format_destination(interDigitTimeout) 20 
	set format_destination(initialDigitTimeout) 20 


        set dir_prefix "ftp://ftp.t72.ru/pub/cisco/tcl/prompts/ru"
        set dir_voice "ftp://ftp.t72.ru/pub/cisco/tcl/prompts/ru"

	set voice_message(boink)     "$dir_voice/notify.au"
	set voice_message(welcome)     "$dir_voice/welcome.au"
	set voice_message(auth_fail) "$dir_voice/auth_fail.au"
	set voice_message(calling)   "$dir_voice/ringin.au"
	set voice_message(auth_fail_final)   "$dir_voice/auth_fail_final.au"
	set voice_message(enter_dest) "$dir_voice/enter_dest.au"
	set voice_message(enter_pin)  "$dir_voice/enter_pin.au"
	set voice_message(enter_uin)  "$dir_voice/enter_card_num.au"
	set voice_message(enter_cancel)  "$dir_voice/auth_fail.au"
	set voice_message(bye)        "$dir_voice/generic_final.au"
	set voice_message(you_have_money)   "$dir_voice/you_have_money.au"
	set voice_message(you_have_minutes)   "$dir_voice/you_have_minutes.au"
	set voice_message(negative_balance)   "$dir_voice/zero_bal.au"
	set voice_message(dest_busy)  "$dir_voice/dest_busy.au"
	set voice_message(dest_unreach) "$dir_voice/dest_unreachable.au"
	set voice_message(low_credit) "$dir_voice/low_credit.au"
	
}
########################################################
proc act_Setup { } {
	global ani
	global dest
	global voice_message
	global format_destination

	puts "\n-------------- act_Setup\n"

    	leg setupack leg_incoming
    	leg proceeding leg_incoming
    	leg connect leg_incoming

	set ani [infotag get leg_ani]

	puts "\n-------------- ANI=$ani\n"

	set av-send(h323-ivr-out,10) "aniphone:true"
	aaa authorize $ani ""  $ani "" leg_incoming av-send
}

########################################################
proc act_GetDest { } {
	global format_destination

	leg collectdigits leg_incoming format_destination
}
########################################################
proc act_GetPin { } {
	global voice_message
	global uin
	global pin
	global ani
	global dest
	

        puts "\n-------------- act_GetPin\n"

	set status [infotag get evt_status]

	if { $status == "cd_002" } {

        	media play leg_incoming $voice_message(enter_cancel) 
		puts "\n ----------- PIN canceled\n"
		fsm setstate ENTER
	
	} else {

		set number [infotag get evt_dcdigits]
		set pin $number

		puts "\n-------------- UIN=$uin PIN=$pin\n"

		set av-send(h323-ivr-out,10) "aniphone:true"
		aaa authorize $uin $pin  $ani $dest leg_incoming av-send
	}
}

########################################################
proc act_Authorized {} {
	global voice_message


	puts "\n-------------- act_Authorized XXX\n"

	global format_destination

	set status [infotag get evt_status]

	puts "\n-------------- AAA AUTHORIZE STATUS=$status"

 	if { $status == "ao_000" } {
		puts "\n-------------- AAA AUTHORIZE=YES \n"

        	### media play leg_incoming "$voice_message(boink) " 
        	playtone leg_incoming tn_dial
		leg collectdigits leg_incoming format_destination 
		fsm setstate GETDEST 

    	} else {
		puts "\n-------------- AAA AUTHORIZE=NO \n"
		media play leg_incoming $voice_message(low_credit) 
		fsm setstate CONNDESTROY 
	}

}
########################################################
proc act_ReAuthorized {} {
	global voice_message
	global amt	
        global x
        global gender_h
        global gender_l
	global currency


	puts "\n-------------- act_ReAuthorized\n"

	global format_destination

	set status [infotag get evt_status]

	if { [infotag get aaa_avpair_exists h323-credit-amount] } {
       		set x [infotag get aaa_avpair h323-credit-amount]
		regsub "{(.*) .* .* .*" $x "\\1"  amt 
		regsub ".* (.*) .* .*" $x "\\1"  gender_h 
		regsub ".* .* (.*) .*" $x "\\1"  gender_l 
		regsub ".* .* .* (.*)}" $x "\\1"  currency 
    	} else { 
		set amt 88888 
		set gender_h 0
		set gender_l 1
		set currency "RUB" 
	}

	puts "\n-------------- AAA AUTHORIZE STATUS=$status"
 	if { $status == "ao_000" && $amt > 0 } {
		puts "\n-------------- AAA AUTHORIZE=YES, CONTINUE, amount=$amt \n"
    	} else {
		puts "\n-------------- AAA AUTHORIZE=NO, DISCONNECT \n"
		act_DestroyRemote
		fsm setstate CONNDESTROYBYCREDIT 
	}
}
########################################################
proc act_BeforeCallAuthorized {} {
	global voice_message
	global tm	
        global x
        global gender
	global format_destination


	puts "\n-------------- act_BeforeCallAuthorized\n"

	set status [infotag get evt_status]

	if { [infotag get aaa_avpair_exists h323-credit-time] } {
       		set x [infotag get aaa_avpair h323-credit-time]
		regsub "{(.*) .*" $x "\\1"  tm 
		regsub ".* (.*)}" $x "\\1"  gender 
    	} else { 
		set tm 88888 
		set gender 1
	}

	puts "\n-------------- AAA AUTHORIZE STATUS=$status, TM=$tm, GENDER=$gender"
 	if { $status == "ao_000" } {
		puts "\n-------------- AAA AUTHORIZE=YES, CONTINUE, credit time=$tm \n"
		### media play leg_incoming $voice_message(calling) 
		fsm setstate PLACECALL
		act_DoCall 

    	} else {
		puts "\n-------------- AAA AUTHORIZE=NO, DISCONNECT \n"
	        puts "\n-------------- ACCOUNT IS BAD, tm < 1 "
	        leg collectdigits leg_incoming format_destination
	        media play leg_incoming $voice_message(low_credit) 
	        fsm setstate GETDEST 
	}
}
########################################################
proc act_DestroyRemote {} {
		puts "\n-------------- DESTROYING REMOTE... \n"
		connection destroy [infotag get con_ofleg leg_outgoing] 
}
########################################################
proc act_Destroyed_ByCredit {} {
	global voice_message

	puts "\n------------ Negative balance, connection destroyed \m"
	media play leg_incoming $voice_message(negative_balance) 
}
########################################################
proc act_DoCall { } {
        puts "\n-------------- act_DoCall\n"

        global dest


        playtone leg_incoming tn_ringback
	infotag set leg_suppress_outgoing_auto_acct 1

        leg setup $dest callInfo leg_incoming
}

########################################################
proc act_CallSetupDone {} {
	global voice_message
	global method
	global format_destination

	puts "\n---- act_CallSetupDone \n"

	playtone leg_incoming tn_none

	set status [infotag get evt_status]

	puts "\n------------ CALL STATUS: $status \n"

	if { $status == "ls_000" } { 

		puts "\n------------ Trying accounting \n"

		set method "h323"
		set av-send(h323-ivr-out,10) "aniphone:true"
		aaa accounting start leg_outgoing -a av-send -s $method 

		act_TimerStart
	} else {
		if { $status == "ls_007"} { 
		
			puts "\n------------ Destination is BUSY\n"
        		media play leg_incoming $voice_message(dest_busy) 
		} else {

			puts "\n------------ Destination is UNREACHABLE\n"
        		media play leg_incoming $voice_message(dest_unreach) 
		}
	}
}

########################################################
proc act_TimerStart {} {
	timer start leg_timer 30 leg_outgoing
}
########################################################
proc act_SendAlive {} {
	global ani
	global dest 
	global method

	puts "\n ------------------ Time to send ALIVE \n"

	act_TimerStart

	set av-send(h323-ivr-out,10) "aniphone:true"
	aaa accounting update leg_outgoing
	aaa authorize $ani "" $ani $dest leg_incoming av-send
}
########################################################

proc act_Cleanup {} {
        puts "\n-------------- act_Cleanup\n"
	call close
}

########################################################
proc act_BeforeCall {} {
	global ani
	global dest
        global number

        set number [infotag get evt_dcdigits]
	set dest "8$number"

	puts "\n-------------- act_BeforeCall";
        puts "\n-------------- DESTINATION NUMBER=$dest\n"

	set av-send(h323-ivr-out,10) "aniphone:true"
	aaa authorize $ani "" $ani $dest leg_incoming av-send
}

########################################################
proc act_Warning {} {
	global voice_message

	puts "\n-------------- Warning played\n"

        media play leg_incoming $voice_message(bye) 
}

########################################################
proc act_Empty {} {
	puts "\n-------------- act_Empty\n"
}

########################################################


########################################################
#
#  Procedures below do all the pronousiation tricks !!!
#
########################################################

proc power10 {x} {
	set p 1
        for { set i 0} {$i<$x} {incr i 1} {
        	set p [expr $p * 10]
        }
	return $p
}


###################################################

proc say_number1000 {x sex dir suffix} {
	global last_digit

	set max_power 3

 	set number_string ""
	set alpha(0,1) 		"a_1m"
	set alpha(0,2) 		"a_2m"
	set alpha(0,3) 		"a_3"
	set alpha(0,4) 		"a_4"
	set alpha(0,5) 		"a_5"
	set alpha(0,6) 		"a_6"
	set alpha(0,7) 		"a_7"
	set alpha(0,8) 		"a_8"
	set alpha(0,9) 		"a_9"
	set alpha(0,10) 	"a_10"
	set alpha(0,11) 	"a_11"
	set alpha(0,12) 	"a_12"
	set alpha(0,13) 	"a_13"
	set alpha(0,14) 	"a_14"
	set alpha(0,15) 	"a_15"
	set alpha(0,16) 	"a_16"
	set alpha(0,17) 	"a_17"
	set alpha(0,18) 	"a_18"
	set alpha(0,19) 	"a_19"
	set alpha(0,20) 	"a_20"
	set alpha(0,30) 	"a_30"
	set alpha(0,40) 	"a_40"
	set alpha(0,50) 	"a_50"
	set alpha(0,60) 	"a_60"
	set alpha(0,70) 	"a_70"
	set alpha(0,80) 	"a_80"
	set alpha(0,90) 	"a_90"
	set alpha(0,100) 	"a_100"
	set alpha(0,200) 	"a_200"
	set alpha(0,300) 	"a_300"
	set alpha(0,400) 	"a_400"
	set alpha(0,500) 	"a_500"
	set alpha(0,600) 	"a_600"
	set alpha(0,700) 	"a_700"
	set alpha(0,800) 	"a_800"
	set alpha(0,900) 	"a_900"



	set alpha(1,1) 		"a_1f"
	set alpha(1,2) 		"a_2f"
	set alpha(1,3) 		"a_3"
	set alpha(1,4) 		"a_4"
	set alpha(1,5) 		"a_5"
	set alpha(1,6) 		"a_6"
	set alpha(1,7) 		"a_7"
	set alpha(1,8) 		"a_8"
	set alpha(1,9) 		"a_9"
	set alpha(1,10) 	"a_10"
	set alpha(1,11) 	"a_11"
	set alpha(1,12) 	"a_12"
	set alpha(1,13) 	"a_13"
	set alpha(1,14) 	"a_14"
	set alpha(1,15) 	"a_15"
	set alpha(1,16) 	"a_16"
	set alpha(1,17) 	"a_17"
	set alpha(1,18) 	"a_18"
	set alpha(1,19) 	"a_19"
	set alpha(1,20) 	"a_20"
	set alpha(1,30) 	"a_30"
	set alpha(1,40) 	"a_40"
	set alpha(1,50) 	"a_50"
	set alpha(1,60) 	"a_60"
	set alpha(1,70) 	"a_70"
	set alpha(1,80) 	"a_80"
	set alpha(1,90) 	"a_90"
	set alpha(1,100) 	"a_100"
	set alpha(1,200) 	"a_200"
	set alpha(1,300) 	"a_300"
	set alpha(1,400) 	"a_400"
	set alpha(1,500) 	"a_500"
	set alpha(1,600) 	"a_600"
	set alpha(1,700) 	"a_700"
	set alpha(1,800) 	"a_800"
	set alpha(1,900) 	"a_900"


	for { set i [expr $max_power - 1] } { $i >= 0 } { incr i -1 } {
        	set p [power10 $i]
		set n [expr $x / $p]
		set x [expr $x % $p]

		set last_digit $n

		set nn [expr $n * $p]
		if { $p == 10 && $n==1} {
			set nn [expr $nn + $x]
			set last_digit 0
			set number_string "$number_string $dir/$alpha($sex,$nn)$suffix"
			break
		} elseif { $nn > 0 } {
			set number_string "$number_string $dir/$alpha($sex,$nn)$suffix"
		}


				
	}

	return $number_string

}
##################################################################33

proc say_number {x dir prefix_0 suffix sex_0 } {
	global last_digit


        set number_string 	""
        set max_power   	6
        set zero  		"zero"


        set power_name(0,0)       "p0_056789"
        set power_name(0,1)       "p0_1"
        set power_name(0,2)       "p0_234"
        set power_name(0,3)       "p0_234"
        set power_name(0,4)       "p0_234"
        set power_name(0,5)       "p0_056789"
        set power_name(0,6)       "p0_056789"
        set power_name(0,7)       "p0_056789"
        set power_name(0,8)       "p0_056789"
        set power_name(0,9)       "p0_056789"

        set power_name(3,1)       "p3_1"
        set power_name(3,2)       "p3_234"
        set power_name(3,3)       "p3_234"
        set power_name(3,4)       "p3_234"
        set power_name(3,5)       "p3_056789"
        set power_name(3,6)       "p3_056789"
        set power_name(3,7)       "p3_056789"
        set power_name(3,8)       "p3_056789"
        set power_name(3,9)       "p3_056789"

        set power_name(6,1)       "p6_1"
        set power_name(6,2)       "p6_234"
        set power_name(6,3)       "p6_234"
        set power_name(6,4)       "p6_234"
        set power_name(6,5)       "p6_056789"
        set power_name(6,6)       "p6_056789"
        set power_name(6,7)       "p6_056789"
        set power_name(6,8)       "p6_056789"
        set power_name(6,9)       "p6_056789"


        #sex 1-mail 0-femail
        set power_sex(0)       	$sex_0
        set power_sex(3)        1
        set power_sex(6)        0


        if {$x == 0} {
                set number_string "$dir/$zero$suffix $dir/$prefix_0$power_name(0,0)$suffix"
                return $number_string
        }


        for { set i $max_power } { $i >= 0 } { incr i -3} {
		if { $i<0 } {
			set i 0
		}

                set sex $power_sex($i)
		set p [power10 $i]
                set n [expr $x / $p]
                set x [expr $x % $p]


		if { $i == 0  } {
			set prefix $prefix_0
		} else {
			set prefix ""
		}

                if { $n > 0 } {

			set result [say_number1000 $n $sex $dir $suffix]
                	set number_string "$number_string $result $dir/$prefix$power_name($i,$last_digit)$suffix"
		}



        }

        return $number_string

}

####################################################################################

proc say_money { x g_d g_c cur } {
	# x -  sum in cents
	global dir_prefix
        set minus         "minus.au"
	set number_string ""

	regsub "\\..*" [expr int([expr $x * 100])] ""  x

        if {$x < 0} {
                set number_string "$dir_prefix/$minus"
                set x [expr 0 - $x]
        }

	set c [expr $x % 100]
	set d [expr $x / 100]

	set dollars [say_number $d $dir_prefix "money_dollars_$cur" ".au" $g_d]

	set cents ""
	if { $c != 0 } {
		set cents [say_number $c $dir_prefix "money_cents_$cur" ".au" $g_c]
	}

	set number_string "$number_string $dollars $cents"


	return "$number_string"
}

####################################################################################

proc say_time { hh mi } {
	global dir_prefix
	set hour [say_number $hh $dir_prefix "time_hours_" ".au" 0]
	set minute [say_number $mi $dir_prefix "time_minutes_" ".au" 1]
	
	return "$hour $minute"

}

####################################################################################

proc say_duration { mi gender } {
        global dir_prefix
	return [say_number $mi $dir_prefix "time_minutes_" ".au" $gender]
}


########################################################
########################################################
########################################################
########################################################

proc act_Debug { } {

	global status

	set status [infotag get evt_status]

	puts "\n-------------- act_Debug: status = $status\n"
}

init

set fsm(INIT,ev_setup_indication) "act_Setup AUTHORIZE"
set fsm(ENTER,ev_media_done) "act_Enter GETUIN"
set fsm(GETUIN,ev_collectdigits_done) "act_GetUin GETPIN"
set fsm(GETPIN,ev_collectdigits_done) "act_GetPin AUTHORIZE"
set fsm(AUTHORIZE,ev_authorize_done)  "act_Authorized GETDEST"
set fsm(GETDEST,ev_collectdigits_done) "act_BeforeCall BEFORECALL"
set fsm(BEFORECALL,ev_authorize_done) "act_BeforeCallAuthorized same_state"
set fsm(BEFORECALL,ev_media_done) "act_DoCall PLACECALL"
set fsm(PLACECALL,ev_setup_done) "act_CallSetupDone CALLACTIVE"
set fsm(CALLACTIVE,ev_media_done) "act_GetDest GETDEST"
set fsm(CALLACTIVE,ev_disconnected)   "act_DestroyRemote CONNDESTROYBYREMOTE"
set fsm(CALLACTIVE,ev_authorize_done)  "act_ReAuthorized same_state"
set fsm(CONNDESTROY,ev_media_done) "act_Cleanup same_state"
set fsm(CONNDESTROYBYCREDIT,ev_destroy_done) "act_Destroyed_ByCredit CONNDESTROY"
set fsm(CONNDESTROYBYREMOTE,ev_destroy_done) "act_Warning CONNDESTROY"
set fsm(CALLACTIVE,ev_leg_timer) "act_SendAlive same_state"
set fsm(any_state,ev_any_event) "act_Debug same_state"


fsm define fsm INIT 
