#!/usr/bin/perl

require "/etc/cherry/cherry.cfg";

require "/usr/lib/cherry/dbaccess";

$oper_id = $ARGV[0];

unless(defined $oper_id) {
	print STDERR "Please specify oper_id\n";
	exit;
}

my %plan_id;
my %tries;

$sth = $dbh->prepare("SELECT client_type FROM base_clients WHERE oper_id = '$oper_id'");

$sth->execute;

while(($client_type) = $sth->fetchrow_array) {
	($plan_id, $tries) = $dbh->selectrow_array("SELECT id, tries FROM caller_plans WHERE name = '_SYSTEM_PLAN_FOR_${client_type}' AND oper_id = '$oper_id'");
	if($plan_id) {
		$plan_id{$client_type} = $plan_id;
		$tries{$client_type} = $tries;
	}
}

# create new job

$dbh->do("INSERT INTO caller_jobs (id, oper_id, name, subject, status) VALUES (nextval('caller_jobs_id_seq'), '$oper_id', '  ', 'debt', 'STOPPED')");

($job_id) = $dbh->selectrow_array("SELECT currval('caller_jobs_id_seq')");

$sth = $dbh->prepare("SELECT base_clients.client_id, telephone_services.user_id, base_clients.client_type, base_clients.balance, base_clients.currency_type FROM base_clients RIGHT JOIN telephone_services USING (oper_id, client_id) WHERE base_clients.oper_id = '$oper_id' AND base_clients.balance < 0 AND base_clients.auto_call > 0 ORDER BY base_clients.client_type");

$sth->execute;

while(($client_id, $user_id, $client_type, $balance, $currency) = $sth->fetchrow_array) {
	$plan_id = $plan_id{$client_type};
	$tries = $tries{$client_type};
	$dbh->do("INSERT INTO caller_spool (id, oper_id, job_id, plan_id, client_id, number, last_call_time, tries_left, status) VALUES (nextval('caller_spool_id_seq'), '$oper_id', $job_id, $plan_id, '$client_id', '$user_id', 0, $tries, 'PENDING')");
}

$dbh->do("UPDATE caller_jobs SET status = 'RUNNING' WHERE id = $job_id");
