#!/usr/bin/perl 
##############################################################################
#
#                    Template Processing Utility
#
##############################################################################

#
# report error (as image)
#

sub report_error {
	$string = shift;

	use GD;

	$font = gdSmallFont;
	@font_size = (6, 12);

	@bg_color = (255, 255, 255);
	@fg_color = (255, 0, 0);

	$width = $font_size[0] * length $string;
	$height = $font_size[1];

	$image = new GD::Image($width, $height);

	$bg_color = $image->colorAllocate(@bg_color);
	$fg_color = $image->colorAllocate(@fg_color);

	$image->transparent($bg_color);

	$image->string($font, 0, 0, $string, $fg_color);

	print $image->png;

	exit;
}

$|=1;

use CGI::Deurl export => 'main';


$operator = $ENV{'REMOTE_USER'};


require "/etc/cherry/cherry.cfg";

require "$CFG::BASE/ucp.cfg";
require "$CFG::BASE/groups.cfg";
require "$CFG::BASE/actions.cfg";

$left_tag='<\?';
$right_tag='\?>';

while( $tpl =~ s/\.\.\//\.\//g ) {}  # sanity check for '..' symbols
while( $language =~ s/\.\.\//\.\//g ) {}  # sanity check for '..' symbols

if( ! defined($language) ) {
   # language was not defined in CGI
   if ( defined( @operators::language{$operator} ) ) {
   	$language = @operators::language{$operator};
   } else {
   	$language = $CFG::DEFAULT_LANGUAGE;
   }
}

$dict_file     = $CFG::DICT."/$language.dict";
require "$dict_file";


$template_file = $CFG::TEMPLATES."/$tpl";
-f $template_file or report_error "File $template_file not exists";


if($ltag) { $left_tag=$ltag }
if($rtag) { $right_tag=$rtag }

### Checking permissions...

$act = $tpl;
$act =~ s/.*\///;

foreach $group (split(' ', @operators::group{$operator})) {
	foreach $action (split(' ', @groups::action{$group})) {

		$act = $action;
		$module = $action;
		$act =~ s/.*[a-z]_([A-Z].*)/\1/g;
		$module =~ s/([a-z])_[A-Z].*/\1/g ;

		### print "Module: $module, action: $act <BR>\n";
		
		foreach $permit_file (split(' ', $actions::action{$module}->{$act} )) {
			### print "$permit_file : $module : $permit_file <BR>";
			if($template_file =~ /$module\/$permit_file/) {
				$permit_flag++;
			}
		}
	}
}

### print "<SCRIPT> alert('$permit_flag') </SCRIPT>";
#### $permit_flag++;

if(! $permit_flag) {
	report_error "$D_PERMISSION_DENIED :: $tpl";
}

### Checking $oper_id. to meet what is listed in @operators::providers...

$permit_flag = 0 if ($oper_id);

foreach $op (split(' ', @operators::providers{$operator})) {
	if( $oper_id eq $op) { $permit_flag++; last; } 
}

#### $permit_flag++;

if( ! $permit_flag) {
	report_error "$D_PERMISSION_DENIED_PROVIDER :: $oper_id'";
}

### Eveything seems to be ok,
### Do the stuff...

do $template_file;

1;
