#!/usr/bin/perl

use strict;
use DBI;


require "/etc/cherry/cherry.cfg";

require "/usr/lib/cherry/dateutils";

my $logfile = "/var/log/cherry/crontab_client_groups.log";



my $sth;
my $sql;
my $rv;

my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

LOG("Client group option processing started");

my $dbh = DBI->connect("dbi:$CFG::DB_TYPE:dbname=$CFG::DB_NAME;host=$CFG::DB_HOST",
                    "$CFG::DB_USER",
                    "$CFG::DB_USER_PASSWORD",
                    { RaiseError => 1, AutoCommit => 0 });

LOG("Database connected");



###
### Zero-Balance-Each-Month feature (ZBEM option in client_gorup);
###

if($mday == 1) {


	$sth = $dbh->prepare("SELECT base_clients.client_id, base_clients.oper_id FROM base_clients, base_client_groups WHERE base_clients.client_group = base_client_groups.group_id AND base_clients.oper_id = base_client_groups.oper_id AND base_client_groups.options ILIKE 'ZBEM' ");

	$sth->execute;

	while( my ($client_id, $oper_id) = $sth->fetchrow_array) {

		$dbh->do("UPDATE base_clients SET balance = 0, change_balance_comment = (CASE WHEN change_balance_comment IS NULL THEN '' ELSE change_balance_comment END  || current_date  || ' ' || 'from ' || to_char(balance,'99999990.9999') || ' to ' || '0' || ' by ' || 'crontab_client_groups.pl' || ' - ' || 'ZBEM feature' || '<BR>' ) WHERE client_id = '$client_id' AND oper_id = '$oper_id'");
        
		$dbh->do("INSERT INTO base_history (date, operator, action, descr) values ('now', 'crontab_client_groups.pl', '', '$oper_id $client_id ZBEM')");

	}

	

	LOG("ZBEM done successfully");

	$dbh->commit;
}

$dbh->disconnect;

LOG("Processing stopped");

##################################################################################

sub LOG {
        my ($msg) = @_;
        my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
                localtime(time);

        my($date) = sprintf "%02d.%02d.%04d %02d:%02d:%02d", $mday, $mon+1, $year+1900, $hour, $min, $sec;

        $msg = $date."\t".$msg;

        open(OUT,">>$logfile");
        print OUT $msg."\n";
        print $msg."\n";
        close(OUT);
}

#################################################################################








