#!/usr/bin/perl

use strict;
use DBI;
use POSIX;


require "/etc/cherry/cherry.cfg";

require "/usr/lib/cherry/dateutils";
require "$CFG::BASE/dicts/russian.dict";

my $logfile = "/var/log/cherry/crontab_monthly_calc.log";



my $sth;
my $sql;
my $rv;

my $mbegin ;
my $mend;
my $service_type;
my $session_type;
my $service_date;
my $month;

my $bill_date;
my $bill_type;
my $bill_currency_type;
my $status;


my $dbh = DBI->connect("dbi:$CFG::DB_TYPE:dbname=$CFG::DB_NAME;host=$CFG::DB_HOST",
                    "$CFG::DB_USER",
                    "$CFG::DB_USER_PASSWORD",
                    { RaiseError => 1, AutoCommit => 1 });



############################################################################################
# 0. telephone
############################################################################################


############################################################################################
# 2. channel
############################################################################################


$mbegin =  month_end(previous_month_begin( time2str(time())) )  . ' 23:59:59';
$mend   =  month_end(previous_month_begin( time2str(time())) )  . ' 23:59:59';

$session_type = 'channel';
$service_type = 'fixed_channel';
$service_date = $mbegin;
$month = month_name( previous_month_begin( time2str(time()) ) );

add_services($mbegin, $mend, $session_type, $service_type, $service_date, $month, 1, undef,'count');

############################################################################################
# 2. dry_pair
############################################################################################

$mbegin = month_end(previous_month_begin( time2str(time())) )  . ' 23:59:59';
$mend   = month_end(previous_month_begin( time2str(time())) )  . ' 23:59:59';

$session_type = 'dry_pair';
$service_type = 'fixed_dry_pair';
$service_date = $mbegin;
$month = month_name( previous_month_begin( time2str(time()) ) );

add_services($mbegin, $mend, $session_type, $service_type, $service_date, $month, 1, undef,'count');


#########################################################################################


#$dbh->commit;
$dbh->disconnect;
exit;

##########################################################################################

sub add_bills {


        my($mbegin, $mend, $bill_date,$bill_type)=@_;


        my $sql = "SELECT DISTINCT oper_id,client_id FROM bill_given_services ".
        " WHERE client_id='7001168' AND service_date BETWEEN '$mbegin' AND '$mend' AND service_sum>0 ".
	" AND (oper_id,client_id,service_id) NOT IN (SELECT oper_id,client_id,service_id from bill_bill_services) AND first_operator='autobill'";

        LOG("SQL:\n$sql\n");

        $sth = $dbh->prepare($sql);
        if( !$sth ) {
                LOG (sprintf("SQLERROR: %s", $dbh->errstr));
                $dbh->rollback;
                exit -1;
        }


        $rv = $sth->execute;
        if( !$rv ) {
                LOG (sprintf("SQLERROR: %s", $dbh->errstr));
                $dbh->rollback;
                exit -1;
        }

	


	while( my ($oper_id,$client_id) =  $sth->fetchrow_array) {

		my $bill_number;
		my $number_format;

		my ($client_type) = $dbh->selectrow_array("SELECT client_type FROM base_clients WHERE oper_id='$oper_id' AND client_id='$client_id'");

		my $bill_status;

                if($CFG::CLIENT_TYPE_ORG=~ /$client_type/) { 
			($bill_number,$number_format) = $dbh->selectrow_array("SELECT bill_number,number_format FROM bill_bill_types WHERE oper_id='$oper_id' AND bill_type='$bill_type'");
                        $bill_number++;
                        $dbh->do("UPDATE bill_bill_types SET bill_number=$bill_number WHERE oper_id='$oper_id' AND bill_type='$bill_type' ");

			$bill_status=1;
                } else {
                        ($bill_number,$number_format) = $dbh->selectrow_array("SELECT bill_number2,number_format FROM bill_bill_types WHERE oper_id='$oper_id' AND bill_type='$bill_type'");
                        $bill_number++;
                        $dbh->do("UPDATE bill_bill_types SET bill_number2=$bill_number WHERE oper_id='$oper_id' AND bill_type='$bill_type' ");

			$bill_status=0;

                }

        	my ($bill_id) = $dbh->selectrow_array("SELECT nextval('base_bills_id_seq') ");

        	my($client_type,$bill_currency_type,$client_with_taxes)= $dbh->selectrow_array("SELECT client_type,bill_currency_type, with_taxes FROM base_clients WHERE oper_id='$oper_id' AND client_id= '$client_id' ");



        	my $sql = "SELECT service_id,currency_type,service_sum,service_date FROM bill_given_services ".
        	" WHERE service_date BETWEEN '$mbegin' AND '$mend' ".
		" AND oper_id='$oper_id' AND client_id='$client_id' AND service_sum>0 ".
        	" AND (oper_id,client_id,service_id) NOT IN (SELECT oper_id,client_id,service_id from bill_bill_services) AND first_operator='autobill'";


        	LOG("SQL:\n$sql\n");

        	my $sth2 = $dbh->prepare($sql);
        	if( !$sth2 ) {
                	LOG (sprintf("SQLERROR: %s", $dbh->errstr));
                	$dbh->rollback;
                	exit -1;
        	}


        	$rv = $sth2->execute;
        	if( !$rv ) {
                	LOG (sprintf("SQLERROR: %s", $dbh->errstr));
                	$dbh->rollback;
                	exit -1;
        	}

                my $bill_sum_without_taxes=0 ;
                my $bill_sum=0;


		$sql="INSERT INTO bill_bills (oper_id,client_id,bill_id,bill_date,bill_number,currency_type,bill_type,bill_sum_without_taxes,bill_sum,first_operator,first_date,bill_status) VALUES ('$oper_id','$client_id','$bill_id','$bill_date','$bill_number','$bill_currency_type', '$bill_type',0,0, 'autobill', current_timestamp,$bill_status)";

        	$dbh->do($sql);


        	while( my ($service_id,$service_currency_type,$service_sum,$service_date) =  $sth2->fetchrow_array) {

        		my ($rate) = $dbh->selectrow_array("SELECT base_currency_history.rate FROM base_currency_history WHERE base_currency_history.currency_from = '$service_currency_type' AND base_currency_history.currency_to = '$bill_currency_type' AND base_currency_history.date <= '$bill_date'  order by base_currency_history.date desc limit 1 ");


        		my  ($taxes) = $dbh->selectrow_array("SELECT taxes FROM bill_bill_taxes WHERE oper_id='$oper_id' AND ( client_type = '$client_type' OR client_type='*') AND ( bill_type = '$bill_type' OR bill_type='*') AND date<='$service_date' ORDER BY date DESC");

                	my $tax_rate = 1;
                	foreach my $tax (split(' ', $taxes)) {
                        	$tax_rate *= ($tax + 100) / 100;
                	}


                	$bill_sum_without_taxes= $service_sum * $rate ;
                	$bill_sum= $bill_sum_without_taxes * $tax_rate;



        		my $tax_rate = 1;
        		foreach my $tax (split(' ', $taxes)) {
                		$tax_rate *= ($tax + 100) / 100;
        		}

        		if(!$client_with_taxes) {
                		$bill_sum_without_taxes= $service_sum * $rate ;
                		$bill_sum= $bill_sum_without_taxes * $tax_rate;
        		} else {
                		$bill_sum=  $service_sum * $rate ;
                		$bill_sum_without_taxes= $bill_sum / $tax_rate;
        		}




			$sql="UPDATE bill_bills SET bill_sum_without_taxes=bill_sum_without_taxes+($bill_sum_without_taxes), bill_sum=bill_sum+($bill_sum) WHERE oper_id='$oper_id' AND client_id='$client_id' AND bill_id='$bill_id'";

			$dbh->do($sql);
 
        		$sql="INSERT INTO bill_bill_services (oper_id,client_id,bill_id,service_id,service_sum,service_sum_with_taxes,first_operator,first_date) VALUES ('$oper_id','$client_id','$bill_id','$service_id',$bill_sum_without_taxes,$bill_sum,'autobill' , current_timestamp)";


			$dbh->do($sql);

		}




	}





}
#########################################################################################





sub add_services {

	my($mbegin, $mend, $session_type, $service_type, $service_date, $month, $addzakaz,$status, $quant_mod)=@_;


	my $sql = "SELECT base_sessions_view.oper_id,base_sessions_view.client_id,base_sessions_view.currency_type,sum(base_sessions_view.amount),count(*),  sum(resource), sum(case when tariff>0 then resource else 0 end )   ";

	$sql .= ", ${session_type}_services.descr " if($addzakaz);

	

	$sql .= " FROM base_sessions_view ";
	$sql .= " JOIN  ${session_type}_services ON base_sessions_view.oper_id=${session_type}_services.oper_id AND base_sessions_view.user_id=${session_type}_services.user_id " if($addzakaz);

	$sql .= " WHERE base_sessions_view.client_id='7001168' AND base_sessions_view.session_begin BETWEEN '$mbegin' AND '$mend' AND base_sessions_view.session_type='$session_type' ";

        $sql .= " AND status=$status " if ($status);

	$sql .= " GROUP BY base_sessions_view.oper_id,base_sessions_view.client_id,base_sessions_view.currency_type ";

	$sql .=",${session_type}_services.descr "  if($addzakaz) ;

	LOG("SQL:\n$sql\n");

	$sth = $dbh->prepare($sql);
	if( !$sth ) {
		LOG (sprintf("SQLERROR: %s", $dbh->errstr));
		$dbh->rollback;
        	exit -1;
	}


	$rv = $sth->execute;
	if( !$rv ) {
		LOG (sprintf("SQLERROR: %s", $dbh->errstr));
		$dbh->rollback;
        	exit -1;
	}


	


	while( my ($oper_id,$client_id,$service_currency_type,$service_sum,$count_,$quant_,$quant_town,$zakaz) =  $sth->fetchrow_array) {

		next if($service_sum==0);
		my($client_exist) = $dbh->selectrow_array("SELECT 1 FROM base_clients WHERE oper_id='$oper_id' AND client_id='$client_id' ");

                next if(!$client_exist);



		my ($service_descr,$unit)=$dbh->selectrow_array("SELECT descr,unit FROM bill_service_types WHERE oper_id='$oper_id' AND service_type='$service_type'");
		if($month) {
			$service_descr=$month . " " . $service_descr;
		}



		if($addzakaz && $zakaz) {
			$service_descr.=" ".$zakaz;
		}

		my ($service_id) = $dbh->selectrow_array("SELECT nextval('bill_given_services_id_seq') ");

 		my($bill_currency_type)= $dbh->selectrow_array("SELECT bill_currency_type FROM base_clients WHERE oper_id='$oper_id' AND client_id= '$client_id' ");


                my $tariff;
		my $quantity;

		if(!$unit) {
			$unit="NULL";
			$quantity="NULL";
			$tariff = "NULL";
			
		} else {


			#### hack !!!!
			if($service_type==2) {
        			#my $sql = "SELECT sum(resource) FROM base_sessions_view WHERE session_begin BETWEEN '$mbegin' AND '$mend' AND session_type='$session_type' AND status=1 AND oper_id='$oper_id' AND client_id='$client_id' AND tariff>0";

				#($quant_)=$dbh->selectrow_array($sql);
				$quant_ = $quant_town;
			}
			###################


			$unit="'$unit'";
			$quantity=$count_ if($quant_mod eq 'count');
			$quantity=$quant_ if($quant_mod eq 'resource');
			$quantity=ceil ( $quant_ / 60.0) if($quant_mod eq 'min');


                	if(!$quantity) {
                        	$quantity="NULL";
                	}

		}
		

		my $sql = "INSERT INTO bill_given_services (service_id,oper_id,client_id,service_date,currency_type, " .
		"service_type,service_sum,descr,unit, first_operator,first_date,quantity) ".
		"VALUES ('$service_id','$oper_id','$client_id','$service_date','$service_currency_type', " .
		"'$service_type',$service_sum,'$service_descr',$unit,'autobill', current_timestamp,$quantity)";


		LOG("SQL:\n$sql\n");

		my $rv = $dbh->do($sql);
		if( !$rv ) {
        		LOG (sprintf("SQLERROR: %s", $dbh->errstr));
			$dbh->rollback;
        		exit -1;
		}

	}

}



##################################################################################

sub LOG {
        my ($msg) = @_;
        my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
                localtime(time);

        my($date) = sprintf "%02d.%02d.%04d %02d:%02d:%02d", $mday, $mon+1, $year+1900, $hour, $min, $sec;

        $msg = $date."\t".$msg;

        open(OUT,">>$logfile");
        print OUT $msg."\n";
        print $msg."\n";
        close(OUT);
}

#################################################################################








