#!/usr/bin/perl

use strict;
use DBI;
use POSIX;


require "/etc/cherry/cherry.cfg";

require "/usr/lib/cherry/dateutils";
require "$CFG::BASE/dicts/russian.dict";

my $logfile = "/var/log/cherry/crontab_monthly_calc.log";



my $sth;
my $sql;
my $rv;

my $mbegin ;
my $mend;
my $service_type;
my $session_type;
my $service_date;
my $month;

my $bill_date;
my $bill_type;
my $bill_currency_type;
my $status;


my $dbh = DBI->connect("dbi:$CFG::DB_TYPE:dbname=$CFG::DB_NAME;host=$CFG::DB_HOST",
                    "$CFG::DB_USER",
                    "$CFG::DB_USER_PASSWORD",
                    { RaiseError => 1, AutoCommit => 0 });



$mbegin = previous_month_begin( time2str(time()) ) ;
$mend   = month_end(previous_month_begin( time2str(time())) )  . ' 23:59:59';
$status = 2;
$session_type = 'telephone';
$service_date = $mend;
$month = month_name($service_date);
$service_type = '10';
add_detail_print($mbegin, $mend, $session_type, $service_type, $service_date,$month,$status);


$dbh->commit;
$dbh->disconnect;
exit;

##########################################################################################

sub add_detail_print{

        my($mbegin, $mend, $session_type, $service_type, $service_date, $month, $status )=@_;


        my $sql = "SELECT base_sessions_view.oper_id,base_sessions_view.client_id,count(*) ";
        $sql .= " FROM base_sessions_view JOIN  base_clients ON base_sessions_view.oper_id=base_clients.oper_id AND base_sessions_view.client_id=base_clients.client_id WHERE base_sessions_view.session_begin BETWEEN '$mbegin' AND '$mend' AND base_sessions_view.session_type='$session_type' AND base_clients.print_trunk=1 ";
        $sql .= " AND status=$status " if ($status);

        $sql .= " GROUP BY base_sessions_view.oper_id,base_sessions_view.client_id,base_sessions_view.currency_type ";


        LOG("SQL:\n$sql\n");

        $sth = $dbh->prepare($sql);
        if( !$sth ) {
                LOG (sprintf("SQLERROR: %s", $dbh->errstr));
                $dbh->rollback;
                exit -1;
        }

        $rv = $sth->execute;
        if( !$rv ) {
                LOG (sprintf("SQLERROR: %s", $dbh->errstr));
                $dbh->rollback;
                exit -1;
        }






        while( my ($oper_id,$client_id,$count_,) =  $sth->fetchrow_array) {

        	my ($service_descr,$unit)=$dbh->selectrow_array("SELECT descr,unit FROM bill_service_types WHERE oper_id='$oper_id' AND service_type='$service_type'");
        	if($month) {
        		$service_descr=$month . " " . $service_descr;
        	}

                my($bill_currency_type)= $dbh->selectrow_array("SELECT bill_currency_type FROM base_clients WHERE oper_id='$oper_id' AND client_id= '$client_id' ");

                my ($client_type) = $dbh->selectrow_array("SELECT client_type FROM base_clients WHERE oper_id='$oper_id' AND client_id='$client_id'");

                my ($tariff) = $dbh->selectrow_array(
                qq{
                        SELECT tariff FROM bill_service_tariffs
                        WHERE oper_id='$oper_id' AND service_type='$service_type' AND
                        date = (SELECT max(date) FROM bill_service_tariffs
                                WHERE oper_id='$oper_id' AND service_type='$service_type' AND
                                date<='$service_date' AND (client_type='*' OR client_type='$client_type')
			)
                });

                my $quantity;
                $quantity= ceil ($count_/ 210.0 );
		my $service_sum = $quantity  * $tariff;



                my $session_id="detailprinted:$oper_id:$client_id:$service_date";

                my ($balance_currency_type) = $dbh->selectrow_array(
                        "SELECT currency_type FROM base_clients WHERE oper_id='$oper_id' AND client_id='$client_id'");


		my $service_currency_type='RUB';

                my ($rate) = $dbh->selectrow_array("SELECT base_currency_history.rate FROM base_currency_history WHERE base_currency_history.currency_from = '$service_currency_type' AND base_currency_history.currency_to = '$balance_currency_type' AND base_currency_history.date <= '$service_date'  order by base_currency_history.date desc limit 1 ");

                if(!$rate) {
			die "Wrong rate!";
                }

                my $amount = $service_sum * $rate ;



		my $sql= "INSERT INTO base_sessions (session_id,session_type,session_begin,status,nas_id) ".
			"VALUES ( '$session_id','$session_type','$service_date',98,'billing') ";

                LOG("SQL:\n$sql\n");

                my $rv = $dbh->do($sql);
                if( !$rv ) {
                        LOG (sprintf("SQLERROR: %s", $dbh->errstr));
                        $dbh->rollback;
                        exit -1;
                }

		$sql= "INSERT INTO base_calculated_sessions (session_id,service_type,direction_descr," .
                "currency_type,amount,resource, resource_type,client_id,oper_id, tariff_id) ".
                "VALUES ('$session_id','$session_type','$service_descr',".
                "'$balance_currency_type',$amount, $quantity , '$unit','$client_id','$oper_id',1) ";


                LOG("SQL:\n$sql\n");

                my $rv = $dbh->do($sql);
                if( !$rv ) {
                        LOG (sprintf("SQLERROR: %s", $dbh->errstr));
                        $dbh->rollback;
                        exit -1;
                }


                $sql= "UPDATE base_clients SET balance = balance - ($amount)::numeric WHERE oper_id='$oper_id' AND client_id='$client_id' ";


                LOG("SQL:\n$sql\n");

                my $rv = $dbh->do($sql);
                if( !$rv ) {
                        LOG (sprintf("SQLERROR: %s", $dbh->errstr));
                        $dbh->rollback;
                        exit -1;
                }





        }

}






##################################################################################

sub LOG {
        my ($msg) = @_;
        my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
                localtime(time);

        my($date) = sprintf "%02d.%02d.%04d %02d:%02d:%02d", $mday, $mon+1, $year+1900, $hour, $min, $sec;

        $msg = $date."\t".$msg;

        open(OUT,">>$logfile");
        print OUT $msg."\n";
        print $msg."\n";
        close(OUT);
}

#################################################################################








