#!/usr/bin/perl

use strict;
use DBI;
use POSIX;


require "/etc/cherry/cherry.cfg";

require "/usr/lib/cherry/dateutils";
require "$CFG::BASE/dicts/russian.dict";

my $logfile = "/var/log/cherry/crontab_monthly_calc.log";



my $sth;
my $sql;
my $rv;

my $mbegin ;
my $mend;



my $dbh = DBI->connect("dbi:$CFG::DB_TYPE:dbname=$CFG::DB_NAME;host=$CFG::DB_HOST",
                    "$CFG::DB_USER",
                    "$CFG::DB_USER_PASSWORD",
                    { RaiseError => 1, AutoCommit => 1 });


$mbegin = previous_month_begin( time2str(time()) ) ;
$mend   = month_end(previous_month_begin( time2str(time())) )  . ' 23:59:59';



$sql= "insert into bill_telephone_detail select '$mbegin',oper_id,client_id,user_id,status,service_sum,case when status=1 then quant else NULL end as quant from ( select oper_id,client_id,user_id,status,sum(amount) as service_sum,sum(resource) as quant from base_sessions_view where session_begin between '$mbegin' and '$mend' and session_type='telephone' and status in (1,2,99) group by oper_id,client_id,user_id,status) as foo where service_sum>0 and  (oper_id,client_id) in (select oper_id,client_id from telephone_services where date_create<'$mend' and (date_expire IS NULL OR date_expire>'$mbegin') group by oper_id,client_id having count(*)>1 ) order by oper_id,client_id" ;

LOG("SQL:\n$sql\n");


my $rv = $dbh->do($sql);
if( !$rv ) {
	LOG (sprintf("SQLERROR: %s", $dbh->errstr));
        $dbh->rollback;
        exit -1;
}

$rv = $dbh->do("TRUNCATE base_sessions_telephone_fast");
if( !$rv ) {
        LOG (sprintf("SQLERROR: %s", $dbh->errstr));
        $dbh->rollback;
        exit -1;
}



$sql= "insert into base_sessions_telephone_fast select * from base_sessions_view WHERE base_sessions_view.session_type='telephone' AND base_sessions_view.session_begin BETWEEN '$mbegin' and '$mend'  AND base_sessions_view.status=2 ";

$rv = $dbh->do($sql);
if( !$rv ) {
        LOG (sprintf("SQLERROR: %s", $dbh->errstr));
        $dbh->rollback;
        exit -1;
}


$rv = $dbh->do("REINDEX TABLE base_sessions_telephone_fast");
if( !$rv ) {
        LOG (sprintf("SQLERROR: %s", $dbh->errstr));
        $dbh->rollback;
        exit -1;
}



$dbh->disconnect;
exit;

##################################################################################

sub LOG {
        my ($msg) = @_;
        my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
                localtime(time);

        my($date) = sprintf "%02d.%02d.%04d %02d:%02d:%02d", $mday, $mon+1, $year+1900, $hour, $min, $sec;

        $msg = $date."\t".$msg;

        open(OUT,">>$logfile");
        print OUT $msg."\n";
        print $msg."\n";
        close(OUT);
}

#################################################################################








