package fixedcalc;

use strict;
no strict "refs";

use DBI;
use Data::Dumper;

my %tariff_plans;
my %tariff_sub_plans;
my %tariffs;
my %services;
my %discounts;



sub reload; 
sub do_cmd; 
sub get_tariff;
sub get_service;



###########################################################################################
sub get_discount {
        my ($oper_id,$client_id,$user_id,$tariff_plan,$tariff_sub_plan,$session_begin) =@_;


        foreach my $discount ( sort{$b->{'date_begin'} cmp $a->{'date_begin'} }
           @{ $discounts{$oper_id}{$client_id}{$user_id}{$tariff_plan}{$tariff_sub_plan} }
        )
        {

                        if ($session_begin ge $discount->{'date_begin'}) {
                                if (! defined($discount->{'date_end'}) ) {
                                        return $discount;
                                } else {
                                        if( $session_begin le $discount->{'date_end'} ) {
                                                return $discount;
                                        }
                                }
                        }


        }


        return;

}
###########################################################################################
sub get_service {
	my ($oper_id,$user_id,$session_begin) =@_;

	foreach my $srv ( sort{$b->{'date_create'} cmp $a->{'date_create'} } 
				@{ $services{$oper_id}{$user_id} }) 
	{

        	if ($session_begin ge $srv->{'date_create'}) {
			if (! defined($srv->{'date_expire'}) ) {
				return $srv;
			} else {
				if( $session_begin le $srv->{'date_expire'} ) {
					return $srv;
				}
                	}
		}

        }

	return;
}

###################################################################################
sub get_tariff {
        my ($oper_id,$tariff_plan,$tariff_sub_plan, $client_type,$session_begin, $session_long) = @_;
	main::LOG ("$oper_id,$tariff_plan,$tariff_sub_plan, $client_type,$session_begin, $session_long");
	#main::LOG("ALLTAR \n". Dumper %tariffs );
	my @found_tariffs;

        foreach my $tariff_ref ( @{ $tariffs{$oper_id}{$tariff_plan}{$tariff_sub_plan} } )
        {


            if(
                ( $session_begin ge $tariff_ref->{date} ) &&
                ( !$tariff_ref->{date_end} || $session_begin le $tariff_ref->{date_end} ) &&
                ( !$tariff_ref->{client_type} || $tariff_ref->{client_type} eq $client_type) 
            ) {

                push @found_tariffs,
                {
                        tariff_ref => $tariff_ref,
                        session_begin => $session_begin,
                        session_end => $session_begin,
                        session_long => $session_long,

                };

                main::LOG ("FOUND TARIFF ... OK\n");



            }


        }


        return @found_tariffs;

}

############################################################################################

sub reload {
	my ($dbh,$service) = @_;

	my $sth;
	my $rv;
	my $sql;

        ########## load tariff_plans #########################################

        $sql = 	"SELECT  oper_id,  ".
		" tariff_plan,  ".
		" tariff_sub_plan,  ".
		" currency_type,  ".
		" unit, ".
		" calc_module  ".
		" FROM  ${service}_tariff_sub_plans ";

        main::LOG("SQL:\n$sql\n") if($main::DEBUG>1);
        $sth = $dbh->prepare($sql);
        if( !$sth ) {
                main::LOG ("ERROR: SQL request syntax error: $! $@") if ($main::DEBUG>0);
                return ;
        }

        $rv = $sth->execute;
        if( !$rv ) {
                main::LOG ("ERROR: SQL request execution error: $! $@") if ($main::DEBUG>0);
                return ;
        }

        while( my ($oper_id,$tariff_plan,$tariff_sub_plan,$currency_type,
		$unit,$calc_module) =  $sth->fetchrow_array) {

                push @{ $tariff_plans{$oper_id}{$tariff_plan} },  
		{
			oper_id => $oper_id, 
			tariff_plan => $tariff_plan,
			tariff_sub_plan => $tariff_sub_plan,
			currency_type => $currency_type, 
			tariff_unit => $unit, 
			calc_module => $calc_module
		};

                $tariff_sub_plans{$oper_id}{$tariff_plan}{$tariff_sub_plan}= 
                {
                        oper_id => $oper_id,
                        tariff_plan => $tariff_plan,
                        tariff_sub_plan => $tariff_sub_plan,
                        currency_type => $currency_type,
                        tariff_unit => $unit,
                        calc_module => $calc_module
                };

        	if (! do "/usr/lib/cherry/tariffsrv/" . $CFG::TARIFFMODULES->{$service}->{$calc_module}->{file} ) {
            		die "FUCK!!! couldn't parse : $@" if $@;
        	}
				
        }

        ########## load tariffs #########################################

        $sql = 	"SELECT  oper_id, ".
		" tariff_plan,  ".
		" tariff_sub_plan,  ".
		" date, date_end, tariff, ".
		" client_type,  ".
		" tariff_id ".
		" FROM ${service}_tariffs ";

        main::LOG("SQL:\n$sql\n") if($main::DEBUG>1);
        $sth = $dbh->prepare($sql);
        if( !$sth ) {
                main::LOG ("ERROR: SQL request syntax error: $! $@") if ($main::DEBUG>0);
                return ;
        }

        $rv = $sth->execute;
        if( !$rv ) {
                main::LOG ("ERROR: SQL request execution error: $! $@") if ($main::DEBUG>0);
                return ;
        }

        while( my ($oper_id,$tariff_plan,$tariff_sub_plan,$date,$date_end,$tariff,
		$client_type, $tariff_id) =  $sth->fetchrow_array) {


                my $calc_module=$tariff_sub_plans{$oper_id}{$tariff_plan}{$tariff_sub_plan}->{calc_module};
                my $calc_module_ref=$CFG::TARIFFMODULES->{$service}->{$calc_module};



			
                push @{ $tariffs{$oper_id}{$tariff_plan}{$tariff_sub_plan} }, 
		{
			oper_id => $oper_id, 
			tariff_plan => $tariff_plan,
			tariff_sub_plan => $tariff_sub_plan,
			date => $date,
			date_end => $date_end,
			tariff => $tariff,
			client_type => $client_type,
			tariff_id => $tariff_id
		};
        }



        ##### load services ###########################

        $sql = 	"SELECT  oper_id, ".
		" client_id, ".
		" user_id, ".
		" date_create, ".
		" date_active, ".
		" date_expire, ".
		" tariff_plan ".
		" FROM ${service}_services ";

        main::LOG("SQL:\n$sql\n") if($main::DEBUG>1);
        $sth = $dbh->prepare($sql);
        if( !$sth ) {
                main::LOG ("ERROR: SQL request syntax error: $! $@") if ($main::DEBUG>0);
                return ;
        }

        $rv = $sth->execute;
        if( !$rv ) {
                main::LOG ("ERROR: SQL request execution error: $! $@") if ($main::DEBUG>0);
                return ;
        }

        while( my ( $oper_id, $client_id, $user_id, $date_create, 
		$date_active,$date_expire,$tariff_plan ) = $sth->fetchrow_array)
	{
		push @{ $services{$oper_id}{$user_id} },
			{
				oper_id => $oper_id,
				client_id => $client_id,
				user_id => $user_id, 
				date_create => $date_create,
				date_active => $date_active,
				date_expire => $date_expire,
				tariff_plan => $tariff_plan,
			};
	};


        ########## load discounts  ########################################

        $sql =  "SELECT  oper_id, ".
                " client_id, ".
                " user_id, ".
                " tariff_plan, ".
                " tariff_sub_plan, ".
                " date_begin, ".
                " date_end, ".
                " discount, ".
                " descr, ".
                " discount_id ".
                " FROM ${service}_discounts ";

        main::LOG("SQL:\n$sql\n") if($main::DEBUG>1);
        $sth = $dbh->prepare($sql);
        if( !$sth ) {
                main::LOG ("ERROR: SQL request syntax error: $! $@") if ($main::DEBUG>0);
                return ;
        }

        $rv = $sth->execute;
        if( !$rv ) {
                main::LOG ("ERROR: SQL request execution error: $! $@") if ($main::DEBUG>0);
                return ;
        }

        while( my ( $oper_id, $client_id, $user_id,
                $tariff_plan,$tariff_sub_plan,$date_begin,$date_end,
                $discount,$descr,$discount_id )
                = $sth->fetchrow_array
        )
        {

                push @{
                        $discounts{$oper_id}{$client_id}{$user_id}{$tariff_plan}{$tariff_sub_plan}                   },

                {
                                oper_id => $oper_id,
                                client_id => $client_id,
                                user_id => $user_id,
                                tariff_plan=>$tariff_plan,
                                tariff_sub_plan=>$tariff_sub_plan,
                                date_begin=>$date_begin,
                                date_end=>$date_end,
                                discount=>$discount,
                                descr=>$descr,
                                discount_id=>$discount_id,
                };
        };

        #main::LOG ("DISCOUNTS\n" . Dumper %discounts);




	return 'OK';

}

##################################################################################
sub do_cmd { 


	my (
		$dbh,
                $cmd,
                $query_id,
                $service_type,
                $session_begin,
                $session_long,
                $user_id,
                $password,
                $nas_id,
                $src_major,
                $src_minor,
                $dst_major,
                $dst_minor,
                $bytes_in,
                $bytes_out,
		$direction_,
		$real_session_id,

	) = @_;



	if( $cmd eq 'fixedcalc') {
                my $ret=&common::save_session (
                $dbh,
                $query_id,
                $service_type,
                $session_begin,
                $session_long,
                $user_id,
                $src_major,
                $src_minor,
                $dst_major,
                $dst_minor,
                0,
                0,
                $nas_id,
                "",
                "",
                "",
                );

                if($ret!~ /OK/) {
                        main::LOG ("ERROR: can't save session") if ($main::DEBUG>0);
                        return;
                }

        } 




        my ($oper_id,$nas_type) = &common::get_oper_id($nas_id);
        if(!defined($oper_id)) {
                main::LOG ("ERROR: oper_id not found (nas_id=$nas_id)") if ($main::DEBUG>0);
                return "ERROR\t$query_id\toper_id not found (nas_id=$nas_id)\n";
        }

        my $srv=get_service($oper_id,$user_id,$session_begin);
        if(!defined($srv)) {
        	main::LOG ( "ERROR:  1 user_id not found " .
                	"(oper_id=$oper_id, user_id=$user_id, session_begin=$session_begin)") 
			if ($main::DEBUG>0);

                return "ERROR\t$query_id\tuser_id not found" .
                	"(oper_id=$oper_id, user_id=$user_id, session_begin=$session_begin)"."\n";

        }

	my $client_id = $srv->{'client_id'};
        if(!defined($client_id)) {
                main::LOG ("ERROR: client_id not found (oper_id=$oper_id, user_id=$user_id)"
			) if ($main::DEBUG>0);

                return "ERROR\t$query_id\tclient_id not found (oper_id=$oper_id, " .
			"user_id=$user_id)\n";
        }

        if(!$srv->{'date_active'}) {
                my $sql="UPDATE ${service_type}_services SET date_active=current_timestamp WHERE ".
                        " oper_id='$oper_id' AND user_id='$user_id'";

                main::LOG("SQL:\n$sql\n") if($main::DEBUG>1);

                my $rv = $dbh->do( $sql );
                if( !$rv ) {
                        main::LOG (sprintf("SQLERROR: %s", $dbh->errstr)) if ($main::DEBUG>0);
                        $dbh->rollback;
                        return ;

                }

                $srv->{'date_active'} = &common::time2str( time );
                $dbh->commit;

        }

        my ($balance,$balance_currency_type,$options,$client_type) =
                        &common::get_client_balance($dbh,$oper_id,$client_id);

        if(!defined($balance) ) {
                main::LOG ("ERROR: can't get balance (oper_id=$oper_id, " .
                "client_id=$client_id)") if ($main::DEBUG>0);

                return "ERROR\t$query_id\tcan't get balance (oper_id=$oper_id, " .
                        "client_id=$client_id)\n";
        }

        if(!defined($balance_currency_type) ) {
                main::LOG ("ERROR: balance's currency_type not found ".
                "(oper_id=$oper_id, client_id=$client_id)") if ($main::DEBUG>0);
                return "ERROR\t$query_id\tbalance's currency_type not found ".
                        "(oper_id=$oper_id, client_id=$client_id)\n";
        }



        my $tariff_plan = $srv->{'tariff_plan'};
	if(!defined($tariff_plan)) {
		main::LOG ("ERROR: tariff_plan not found (oper_id=$oper_id, " .
		"user_id=$user_id)") if ($main::DEBUG>0);
		return "ERROR\t$query_id\ttariff_plan not found (oper_id=$oper_id, ".
		"user_id=$user_id)\n";
	}



	my @found_tariffs;


	my $amount;
	my $resource;
 	my $resource_type; 

	my $tariff_sub_plan;
	my $tariff_plan_currency_type ;

	my $tariff;
	my $tariff_unit;
	my $tariff_id;


	my $bytes=$bytes_out;
	my $update_direction=0;


	foreach my $tariff_plan_hash ( @{$tariff_plans{$oper_id}{$tariff_plan}} ) {

	     my	$tp_ref=$tariff_plan_hash;

		$tariff_sub_plan = $tp_ref->{tariff_sub_plan};
		my $calc_module=$tariff_sub_plans{$oper_id}{$tariff_plan}{$tariff_sub_plan}->{calc_module};
		my $calc_module_ref=$CFG::TARIFFMODULES->{$service_type}->{$calc_module};


		my $process_tariffsubplan =  (
			($cmd eq 'fixedcalc' && $calc_module_ref->{fixedcalc}) ||
                        (!($cmd eq 'fixedcalc') && !($calc_module_ref->{fixedcalc}) )
		); 

		if(! $process_tariffsubplan) {
			#main::LOG("DEBUG SKIP THIS TARIFF SUB PLAN");
			next;
		}; 

		

		push @found_tariffs,
		get_tariff( $oper_id,$tariff_plan,$tariff_sub_plan,
                $client_type,$session_begin,$session_long );


        }


	my $found_len =@found_tariffs;
        if(!($found_len>0)) {
                main::LOG ("ERROR: tariff not found (oper_id=$oper_id, " .
                " tariff_plan=$tariff_plan, tariff_sub_plan=$tariff_sub_plan, " .
                " session_begin=$session_begin)") if ($main::DEBUG>0);

                return "ERROR\t$query_id\ttariff not found (oper_id=$oper_id, " .
                "tariff_plan=$tariff_plan, tariff_sub_plan=$tariff_sub_plan, ".
                "session_begin=$session_begin)\n";
        }

	my $sum_session_long_calc=0;

	foreach my $tariff_hash (@found_tariffs) {

		$sum_session_long_calc +=$tariff_hash->{session_long};

                my $tariff_ref=$tariff_hash->{tariff_ref};


		my $tariff_sub_plan = $tariff_ref->{tariff_sub_plan};
		my $tp_ref=$tariff_sub_plans{$oper_id}{$tariff_plan}{$tariff_sub_plan};

                $tariff_id= $tariff_ref->{tariff_id};
                $tariff = $tariff_ref->{tariff};

                $tariff_unit=$tp_ref->{'tariff_unit'};


		if(!defined($tariff)) {
		main::LOG ("ERROR: tariff not found (oper_id=$oper_id, " .
		" tariff_plan=$tariff_plan, tariff_sub_plan=$tariff_sub_plan, " .
		" session_begin=$session_begin)") if ($main::DEBUG>0);

		return "ERROR\t$query_id\ttariff not found (oper_id=$oper_id, " .
		"tariff_plan=$tariff_plan, tariff_sub_plan=$tariff_sub_plan, ".
		"session_begin=$session_begin)\n";
		}




		my $session_begin_calc=$tariff_hash->{session_begin};
		my $session_long_calc=$tariff_hash->{session_long};

                my $discount = get_discount ($oper_id,$client_id,$srv->{user_id},
                                $tariff_plan,$tariff_sub_plan,$session_begin_calc);

                if( defined($discount) ) {
                        my $d = $discount->{discount};
                        if ( defined($d) ) {
                               $tariff = $tariff * ( 100 - $d ) / 100 ;
                                #main::LOG ("DISCOUNT FOUND $d") ;
                        } else {
                                #main::LOG ("DISCOUNT CRUSH !!!!") ;
                        }

                } else {

                        #main::LOG ("DISCOUNT NOT FOUND $oper_id,$client_id,$user_id,$tariff_plan,$tariff_sub_plan,$session_begin_calc");

                }



                my $calc_module=$tp_ref->{calc_module};
                my $calc_module_ref=$CFG::TARIFFMODULES->{$service_type}->{$calc_module};

       		( $resource, $resource_type, $amount ) = 
		&{ $calc_module_ref->{'package'} . '::calc'} 
		( $session_begin_calc, $session_long_calc, 0, $tariff, $tariff_unit, $nas_type );

        	if(!defined($amount)) {
        		main::LOG ("ERROR: can't calc (oper_id=$oper_id, " .
			"tariff_plan=$tariff_plan, session_begin=$session_begin, " . 
			"session_long=$session_long, src_major=$src_major, " .
			"dst_major=$dst_major, bytes=$bytes_out)") if ($main::DEBUG>0);

                	return "ERROR\t$query_id\tcan't calc (oper_id=$oper_id, " .
			"tariff_plan=$tariff_plan, session_begin=$session_begin," .
			"session_long=$session_long, src_major=$src_major, " .
			"dst_major=$dst_major, bytes=$bytes_out)\n";

        	}

		$tariff_plan_currency_type = $tp_ref->{'currency_type'};
		if(!defined($tariff_plan_currency_type)) {
                	main::LOG ("ERROR: tariff_plan's currency_type not found " .
			"(oper_id=$oper_id, tariff_plan=$tariff_plan , tariff_sub_plan=" . 
			$tariff_sub_plan . ")" ) if ($main::DEBUG>0);

			return "ERROR\t$query_id\ttariff_plan's currency_type not found " .
			"(oper_id=$oper_id, tariff_plan=$tariff_plan , tariff_sub_plan=" . 
			$tariff_sub_plan . ")\n";
		}


        	$amount = &common::translate_currency ( $oper_id, $tariff_plan_currency_type, 
					$balance_currency_type, $session_begin,$amount );

        	if(!defined($amount)) {
        		main::LOG ("ERROR: Can't translate currency (oper_id=$oper_id, " .
			"tariff_plan_currency_type=$tariff_plan_currency_type, " .
			"balance_currency_type=$balance_currency_type, session_begin=$session_begin," .
			" amount=$amount)") if ($main::DEBUG>0);

                	return "ERROR\t$query_id\tcan't translate currency (oper_id=$oper_id, " .
			" tariff_plan_currency_type=$tariff_plan_currency_type, " .
			" balance_currency_type=$balance_currency_type, session_begin=$session_begin, " .
			" amount=$amount)\n";
        	}

        	main::LOG("CALC RESULT: resource=$resource resource_type=$resource_type " .
		"amount=$amount\n") if($main::DEBUG>1);


		my $update_type=0;




        	if ( 
			($cmd eq 'fixedcalc' && ($resource_type eq 'month' || $resource_type eq 'day' ) )
		) {


			my $direction_descr;
			if($cmd eq 'fixedcalc') {
				$direction_descr = " ";
			};

                my	$ret = &common::update_balance (
			$update_type,
                        $dbh,
                        $query_id,
                        $resource,
                        $resource_type,
                        "",
                        "",
                        $balance_currency_type,
                        $amount,
                        $user_id,
                        $oper_id,
                        $client_id,
			$tariff_plan,
			$tariff_sub_plan,
                	$direction_descr,
                	$tariff,
                	$tariff_id,
			0,
			$service_type,
			"",
			$session_begin_calc,
			$session_long_calc,

                	);

                	if(!($ret eq 'OK')) {
                        	main::LOG ("ERROR: can't update balance") if ($main::DEBUG>0);
                        	return "ERROR\t$query_id\tcan't update balance\n";
                	}


		} 





	}# foreach tariff


	################
	#     
	#


        if($sum_session_long_calc<$session_long) {

                main::LOG ("ERROR: not all tariffs found sum_session_long=$sum_session_long_calc, " .
                " session_long=$session_long " ) if ($main::DEBUG>0);

                return "ERROR\t$query_id\t not all tariffs found " .
		"sum_session_long=$sum_session_long_calc, session_long=$session_long \n";
        }






	main::LOG ("END CALCULATION GET BALANCE AND RETURN") if ($main::DEBUG>1);


        return "OK\t$query_id\t$balance\t-1\t$balance_currency_type\n";

}
#########################################################################
1;

