package inet_dynamic_ip;

use strict;
no strict "refs";

use DBI;
use Data::Dumper;
use mschap2;

my %tariff_plans;
my %tariff_sub_plans;
my %tariffs;
my %services;
my %directions;
my %discounts;



sub reload; 
sub do_cmd; 
sub get_tariff;
sub get_direction;
sub get_service;



###########################################################################################
sub get_discount {
        my ($oper_id,$client_id,$user_id,$tariff_plan,$tariff_sub_plan,$session_begin) =@_;


        foreach my $discount ( sort{$b->{'date_begin'} cmp $a->{'date_begin'} }
           @{ $discounts{$oper_id}{$client_id}{$user_id}{$tariff_plan}{$tariff_sub_plan} }
        )
        {

                        if ($session_begin ge $discount->{'date_begin'}) {
                                if (! defined($discount->{'date_end'}) ) {
                                        return $discount;
                                } else {
                                        if( $session_begin le $discount->{'date_end'} ) {
                                                return $discount;
                                        }
                                }
                        }


        }


        return;

}
###########################################################################################
sub get_service {
	my ($oper_id,$user_id,$session_begin) =@_;

	foreach my $srv ( sort{$b->{'date_create'} cmp $a->{'date_create'} } 
				@{ $services{$oper_id}{$user_id} }) 
	{

        	if ($session_begin ge $srv->{'date_create'}) {
			if (! defined($srv->{'date_expire'}) ) {
				return $srv;
			} else {
				if( $session_begin le $srv->{'date_expire'} ) {
					return $srv;
				}
                	}
		}

        }

	return;
}

###################################################################################
sub get_tariff {
        my ($oper_id,$tariff_plan,$tariff_sub_plan,$nas_id,$tariff_zone,
                $client_type,$session_begin,$counter,$notariffzone, $session_long, $bytes,
                $counter_resource_type,$divide_by) = @_;




        my $divide_by_time_zone=($divide_by eq 'time');
        my $divide_by_counter=($divide_by eq 'counter');

        my $session_end = common::time2str(common::str2time($session_begin) + $session_long );
	my $session_begin_calc=$session_begin;
	my $session_end_calc =$session_end;
	my $session_long_calc =$session_long;


        my $resource_begin = $counter * 1;
        my $resource;

        if($counter_resource_type eq 'sec') {
                $resource = $session_long;
        } elsif ($counter_resource_type eq 'byte') {
                $resource = $bytes;
        }

        my $resource_end = $resource_begin + $resource ;
	my $resource_begin_calc=$resource_begin;
	my $resource_end_calc=$resource_end;
        my $resource_calc=$resource;

	my $bytes_calc = $bytes;


        my @found_tariffs;



        foreach my $tariff_ref ( @{ $tariffs{$oper_id}{$tariff_plan}{$tariff_sub_plan} } )
        {


            if(
                ( $session_begin ge $tariff_ref->{date} ) &&
                ( !$tariff_ref->{date_end} || $session_begin le $tariff_ref->{date_end} ) &&
                ( !$tariff_ref->{nas_id} || $tariff_ref->{nas_id} eq $nas_id) &&
                ( $notariffzone || !$tariff_ref->{tariff_zone} ||
                                $tariff_ref->{tariff_zone} eq $tariff_zone) &&
                ( !$tariff_ref->{client_type} || $tariff_ref->{client_type} eq $client_type) &&
                ( !$tariff_ref->{day_type} || $tariff_ref->{day_type} eq
                                &common::type_of_day($oper_id,$session_begin) ) &&

                (
                        (!$divide_by_time_zone &&
                                (!$tariff_ref->{time_from} || !$tariff_ref->{time_to}  ||
                                        &common::check_time_zone(
                                        $session_begin,
                                        $tariff_ref->{time_from},
                                        $tariff_ref->{time_to}
                                        )
                                )
                        ) ||
                        ($divide_by_time_zone &&
                                (!$tariff_ref->{time_from} || !$tariff_ref->{time_to}  ||

                                        &common::check_time_zone(
                                        $session_begin,
                                        $tariff_ref->{time_from},
                                        $tariff_ref->{time_to}
                                        ) ||

                                        &common::check_time_zone(
                                        $session_end,
                                        $tariff_ref->{time_from},
                                        $tariff_ref->{time_to}
                                        ) ||

                                        &common::check_time_zone(
                                        $tariff_ref->{time_from},
                                        common::get_time_from_str($session_begin),
                                        common::get_time_from_str($session_end),
                                        )
                                )


                         )
                ) &&

                (
                        (!$divide_by_counter &&
                                (!defined($tariff_ref->{counter1_from}) || !defined($tariff_ref->{counter1_to})

                                        || ($tariff_ref->{counter1_from} <= $resource_begin &&
                                        $resource_begin < $tariff_ref->{counter1_to} )
                                )
                        ) ||
                        ($divide_by_counter &&
                                 (!defined($tariff_ref->{counter1_from}) || !defined($tariff_ref->{counter1_to})
                                        || ($tariff_ref->{counter1_from} <= $resource_begin &&
                                        $resource_begin < $tariff_ref->{counter1_to} )

                                        || ($tariff_ref->{counter1_from} <= $resource_end  &&
                                        $resource_end < $tariff_ref->{counter1_to} )

                                        || ($resource_begin <= $tariff_ref->{counter1_from} &&
                                        $tariff_ref->{counter1_from} < $resource_end)
                                )

                        )


                )


            ) {




                if($divide_by_time_zone) {

                        #     
                        #     
                        if( !$tariff_ref->{time_from} || !$tariff_ref->{time_to} ||
                                &common::check_time_zone(
                                        $session_begin,
                                        $tariff_ref->{time_from},
                                        $tariff_ref->{time_to}
                                )


                                &&

                                &common::check_time_zone(
                                        $session_end,
                                        $tariff_ref->{time_from},
                                        $tariff_ref->{time_to}
                                )
                        )
                        {

                                $session_begin_calc = $session_begin;
                                $session_end_calc = $session_end;
                        }
                        #     ,   
                        elsif (

                                &common::check_time_zone(
                                        $session_begin,
                                        $tariff_ref->{time_from},
                                        $tariff_ref->{time_to}
                                )

                                &&

                                ! &common::check_time_zone(
                                        $session_end,
                                        $tariff_ref->{time_from},
                                        $tariff_ref->{time_to}
                                )


                        )
                        {

                                $session_begin_calc=$session_begin;
                                $session_end_calc = common::get_date_from_str($session_begin).' '.
                                                 $tariff_ref->{time_to};
                        }

                        #      ,   
                        elsif (

                                ! &common::check_time_zone(
                                        $session_begin,
                                        $tariff_ref->{time_from},
                                        $tariff_ref->{time_to}
                                )

                                &&

                                &common::check_time_zone(
                                        $session_end,
                                        $tariff_ref->{time_from},
                                        $tariff_ref->{time_to}
                                )


                        )
                        {

                                $session_begin_calc=common::get_date_from_str($session_begin).' '.
                                                $tariff_ref->{time_from};

                                $session_end_calc = $session_end ;
                        }

                        #    
                        else{

                                $session_begin_calc=common::get_date_from_str($session_begin).' '.
                                                $tariff_ref->{time_from};

                                $session_end_calc = common::get_date_from_str($session_begin).' '.
                                                         $tariff_ref->{time_to};


                        }

                        if(!$session_begin_calc || !$session_end_calc) {
                                main::LOG ("   ") if($main::DEBUG > 0);
                                return ();
                        }



                        $session_long_calc = common::str2time($session_end_calc) -
                                        common::str2time($session_begin_calc) ;

			#main::LOG("FUCK begin=$session_begin_calc end=$session_end_calc session_long_calc=$session_long_calc");
                }


                #>>>>>>>>>>>> counters


                if ($divide_by_counter) {
                        #   x 
                        #     
                        if( !defined($tariff_ref->{counter1_from}) ||
                                !defined($tariff_ref->{counter1_to}) ||

                                ($tariff_ref->{counter1_from} <= $resource_begin &&
                                $resource_begin < $tariff_ref->{counter1_to} )

                                &&

                                ($tariff_ref->{counter1_from} <= $resource_end  &&
                                $resource_end < $tariff_ref->{counter1_to} )

                        )
                        {

                                $resource_begin_calc = $resource_begin;
                                $resource_end_calc = $resource_end;

                        }

                        #     ,   
                        elsif (

                                ($tariff_ref->{counter1_from} <= $resource_begin &&
                                $resource_begin < $tariff_ref->{counter1_to} )

                                &&

                                !($tariff_ref->{counter1_from} <= $resource_end  &&
                                $resource_end < $tariff_ref->{counter1_to} )
                        )
                        {

                                $resource_begin_calc=$resource_begin;
                                $resource_end_calc = $tariff_ref->{counter1_to};
                        }


                        #      ,   
                        elsif (

                                !($tariff_ref->{counter1_from} <= $resource_begin &&
                                $resource_begin < $tariff_ref->{counter1_to} )

                                &&

                                ($tariff_ref->{counter1_from} <= $resource_end  &&
                                $resource_end < $tariff_ref->{counter1_to} )

                        )
                        {

                                $resource_begin_calc = $tariff_ref->{counter1_from};
                                $resource_end_calc = $resource_end ;

                        }

                        #    
                        else{
                                $resource_begin_calc= $tariff_ref->{counter1_from};
                                $resource_end_calc = $tariff_ref->{counter1_to};
                        }



                        if(!defined($resource_begin_calc) || !defined($resource_end_calc)) {
                                main::LOG ("  ") if($main::DEBUG > 0);
                                return ();
                        }


                        $resource_calc = $resource_end_calc - $resource_begin_calc ;


                        if($counter_resource_type eq 'sec') {
                                $session_long_calc=$resource_calc;
                        } elsif ($counter_resource_type eq 'byte') {
                                $bytes_calc = $resource_calc;
                        }


                }




                push @found_tariffs,
                {
                        tariff_ref => $tariff_ref,
                        session_begin => $session_begin_calc,
                        session_end => $session_end_calc,
                        session_long => $session_long_calc,
                        bytes => $bytes_calc,
                        resource_end_calc => $resource_end_calc,
                        resource_begin_calc => $resource_begin_calc,

                };

                #main::LOG ("FOUND TARIFF ... OK\n");



            }


        }


        return @found_tariffs;

}

############################################################################################
sub get_direction  {
        my ($oper_id,$zone_plan,$src_addr,$dst_addr,$direction_) = @_;

        foreach my $direction (sort {$a->{'order_'} <=> $b->{'order_'} } 
				@{ $directions{$oper_id}{$zone_plan}{$direction_} } ) 
	{
            my ($src_ip_addr,)=common::get_inet_addr($src_addr."/".$direction->{'src_ip_mask'});
            my ($dst_ip_addr,)=common::get_inet_addr ($dst_addr."/".$direction->{'dst_ip_mask'});

            if 	(	$src_ip_addr == $direction->{'src_ip_addr'} && 
			$dst_ip_addr == $direction->{'dst_ip_addr'} 
		) 
	    {
			return $direction;
            }

        }

        return;
}
###################################################################################

sub reload {
	my ($dbh,$service) = @_;

	my $sth;
	my $rv;
	my $sql;

        ########## load tariff_plans #########################################

        $sql = 	"SELECT  oper_id,  ".
		" tariff_plan,  ".
		" tariff_sub_plan,  ".
		" zone_plan, ".
		" currency_type,  ".
		" unit, ".
		" calc_module  ".
		" FROM  ${service}_tariff_sub_plans ";

        main::LOG("SQL:\n$sql\n") if($main::DEBUG>1);
        $sth = $dbh->prepare($sql);
        if( !$sth ) {
                main::LOG ("ERROR: SQL request syntax error: $! $@") if ($main::DEBUG>0);
                return ;
        }

        $rv = $sth->execute;
        if( !$rv ) {
                main::LOG ("ERROR: SQL request execution error: $! $@") if ($main::DEBUG>0);
                return ;
        }

        while( my ($oper_id,$tariff_plan,$tariff_sub_plan,$zone_plan,$currency_type,
		$unit,$calc_module) =  $sth->fetchrow_array) {

                push @{ $tariff_plans{$oper_id}{$tariff_plan} },  
		{
			oper_id => $oper_id, 
			tariff_plan => $tariff_plan,
			tariff_sub_plan => $tariff_sub_plan,
			zone_plan => $zone_plan, 
			currency_type => $currency_type, 
			tariff_unit => $unit, 
			calc_module => $calc_module
		};

                $tariff_sub_plans{$oper_id}{$tariff_plan}{$tariff_sub_plan}= 
                {
                        oper_id => $oper_id,
                        tariff_plan => $tariff_plan,
                        tariff_sub_plan => $tariff_sub_plan,
                        zone_plan => $zone_plan,
                        currency_type => $currency_type,
                        tariff_unit => $unit,
                        calc_module => $calc_module
                };

        	if (! do "/usr/lib/cherry/tariffsrv/" . $CFG::TARIFFMODULES->{$service}->{$calc_module}->{file} ) {
            		die "FUCK!!! couldn't parse : $@" if $@;
        	}
				
        }

        ########## load tariffs #########################################

        $sql = 	"SELECT  oper_id, ".
		" tariff_plan,  ".
		" tariff_sub_plan,  ".
		" date, date_end, tariff, ".
		" zone_plan,  ".
		" tariff_zone,  ".
		" client_type,  ".
		" day_type, ".
		" time_from,  ".
		" time_to,  ".
		" counter1_from,  ".
		" counter1_to , ".
		" host,  ".
		" tariff_id ".
		" FROM ${service}_tariffs ";

        main::LOG("SQL:\n$sql\n") if($main::DEBUG>1);
        $sth = $dbh->prepare($sql);
        if( !$sth ) {
                main::LOG ("ERROR: SQL request syntax error: $! $@") if ($main::DEBUG>0);
                return ;
        }

        $rv = $sth->execute;
        if( !$rv ) {
                main::LOG ("ERROR: SQL request execution error: $! $@") if ($main::DEBUG>0);
                return ;
        }

        while( my ($oper_id,$tariff_plan,$tariff_sub_plan,$date,$date_end,$tariff,$zone_plan, 
		$tariff_zone, $client_type, $day_type, $time_from, $time_to, 
		$counter1_from, $counter1_to, $nas_id, $tariff_id) =  $sth->fetchrow_array) {


                my $calc_module=$tariff_sub_plans{$oper_id}{$tariff_plan}{$tariff_sub_plan}->{calc_module};
                my $calc_module_ref=$CFG::TARIFFMODULES->{$service}->{$calc_module};
		my $counter_unit = $calc_module_ref->{counter_unit};
		my $tariff_unit = $tariff_sub_plans{$oper_id}{$tariff_plan}{$tariff_sub_plan}->{tariff_unit};

		if($counter1_from) {
			$counter1_from = &common::translate_unit($tariff_unit,$counter_unit,$counter1_from);
        		if(!defined($counter1_from)) {
                		main::LOG ("ERROR: can't translate unit from $tariff_unit to $counter_unit)");
                		#return;
        		}
		}

                if($counter1_to) {
                        $counter1_to = &common::translate_unit($tariff_unit,$counter_unit,$counter1_to);
                        if(!defined($counter1_to)) {
                                main::LOG ("ERROR: can't translate unit from $tariff_unit to $counter_unit)");
                                #return;
                        }
                }




			
                push @{ $tariffs{$oper_id}{$tariff_plan}{$tariff_sub_plan} }, 
		{
			oper_id => $oper_id, 
			tariff_plan => $tariff_plan,
			tariff_sub_plan => $tariff_sub_plan,
			date => $date,
			date_end => $date_end,
			tariff => $tariff,
			zone_plan => $zone_plan,
			tariff_zone => $tariff_zone,
			client_type => $client_type,
			day_type => $day_type,
			time_from => $time_from,
			time_to => $time_to,
			counter1_from => $counter1_from,
			counter1_to => $counter1_to,
			nas_id => $nas_id,
			tariff_id => $tariff_id
		};
        }



        ##### load services ###########################

        $sql = 	"SELECT  oper_id, ".
		" client_id, ".
		" user_id, ".
		" enabled, ".
		" date_create, ".
		" date_active, ".
		" date_expire, ".
		" tariff_plan, ".
		" water_mark, ".
		" password, ".
		" password_type, ".
		" callback, ".
		" preferred_ip_address, ".
		" max_connections, ".
		" ani, " .
		" session_time_limit, " .
		" ip_filter " .
		" FROM ${service}_services ";

        main::LOG("SQL:\n$sql\n") if($main::DEBUG>1);
        $sth = $dbh->prepare($sql);
        if( !$sth ) {
                main::LOG ("ERROR: SQL request syntax error: $! $@") if ($main::DEBUG>0);
                return ;
        }

        $rv = $sth->execute;
        if( !$rv ) {
                main::LOG ("ERROR: SQL request execution error: $! $@") if ($main::DEBUG>0);
                return ;
        }

        while( my ( $oper_id, $client_id, $user_id, $enabled,$date_create, 
		$date_active,$date_expire,$tariff_plan,$water_mark,$password,$password_type,
		$callback,$preferred_ip_address,$max_connections,$ani,$session_time_limit,$ip_filter) = $sth->fetchrow_array)
	{
		push @{ $services{$oper_id}{$user_id} },
			{
				oper_id => $oper_id,
				client_id => $client_id,
				user_id => $user_id, 
				enabled => $enabled,
				date_create => $date_create,
				date_active => $date_active,
				date_expire => $date_expire,
				tariff_plan => $tariff_plan,
				water_mark => $water_mark,
				password => $password,
				password_type => $password_type,
				callback => $callback,
				preferred_ip_address => $preferred_ip_address,
				max_connections => $max_connections,
				ani => $ani,
				session_time_limit => $session_time_limit,
				ip_filter => $ip_filter,
			};
	};


        ########## load discounts  ########################################

        $sql =  "SELECT  oper_id, ".
                " client_id, ".
                " user_id, ".
                " tariff_plan, ".
                " tariff_sub_plan, ".
                " date_begin, ".
                " date_end, ".
                " discount, ".
                " descr, ".
                " discount_id ".
                " FROM ${service}_discounts ";

        main::LOG("SQL:\n$sql\n") if($main::DEBUG>1);
        $sth = $dbh->prepare($sql);
        if( !$sth ) {
                main::LOG ("ERROR: SQL request syntax error: $! $@") if ($main::DEBUG>0);
                return ;
        }

        $rv = $sth->execute;
        if( !$rv ) {
                main::LOG ("ERROR: SQL request execution error: $! $@") if ($main::DEBUG>0);
                return ;
        }

        while( my ( $oper_id, $client_id, $user_id,
                $tariff_plan,$tariff_sub_plan,$date_begin,$date_end,
                $discount,$descr,$discount_id )
                = $sth->fetchrow_array
        )
        {

                push @{
                        $discounts{$oper_id}{$client_id}{$user_id}{$tariff_plan}{$tariff_sub_plan}                   },

                {
                                oper_id => $oper_id,
                                client_id => $client_id,
                                user_id => $user_id,
                                tariff_plan=>$tariff_plan,
                                tariff_sub_plan=>$tariff_sub_plan,
                                date_begin=>$date_begin,
                                date_end=>$date_end,
                                discount=>$discount,
                                descr=>$descr,
                                discount_id=>$discount_id,
                };
        };

        #main::LOG ("DISCOUNTS\n" . Dumper %discounts);




        ########## load directions #########################################

        $sql = 	"SELECT  oper_id, ".
		" zone_plan, ".
		" tariff_zone, ".
		" src,dst, ".
		" order_, ".
		" direction, ".
		" direction_id, ".
		" descr  ".
		" FROM ${service}_directions  ";

        main::LOG("SQL:\n$sql\n") if($main::DEBUG>1);
        $sth = $dbh->prepare($sql);
        if( !$sth ) {
                main::LOG ("ERROR: SQL request syntax error: $! $@") if ($main::DEBUG>0);
                return ;
        }

        $rv = $sth->execute;
        if( !$rv ) {
                main::LOG ("ERROR: SQL request execution error: $! $@") if ($main::DEBUG>0);
                return ;
        }

        while( my ($oper_id,$zone_plan,$tariff_zone,$src,$dst,$order_,$direction,
		$direction_id,$descr) =  

		$sth->fetchrow_array) {
                my ($src_ip_addr,$src_ip_mask) = &common::get_inet_addr($src);
                if( ! (length($src_ip_addr)>0 ) ) {
                        main::LOG ("ERROR: Can't get_inet_addr($src)");
                        return ;
                }


                my ($dst_ip_addr,$dst_ip_mask) = &common::get_inet_addr($dst);
                if( ! (length($dst_ip_addr)>0 ) ) {
                        main::LOG ("ERROR: Can't get_inet_addr($dst)");
                        return ;
                }

		push @{ $directions{$oper_id}{$zone_plan}{$direction} }, 
		{
			oper_id=>$oper_id,
			zone_plan=>$zone_plan,
			tariff_zone=>$tariff_zone,
			src=>$src,
			dst=>$dst,
			order_=>$order_,
			direction=>$direction,
			src_ip_addr=>$src_ip_addr, 
			src_ip_mask=>$src_ip_mask,
			dst_ip_addr=>$dst_ip_addr, 
			dst_ip_mask=>$dst_ip_mask,
			direction_id=>$direction_id, 
			descr=>$descr,
		};

        }


	return 'OK';

}

##################################################################################
sub do_cmd { 


	my (
		$dbh,
                $cmd,
                $query_id,
                $service_type,
                $session_begin,
                $session_long,
                $user_id,
                $password,
                $nas_id,
                $src_major,
                $src_minor,
                $dst_major,
                $dst_minor,
                $bytes_in,
                $bytes_out,
		$direction_,
		$real_session_id,

	) = @_;


        my $MSCHAPAuthenticatorResponse; ### This must be calculated during MS-CHAPv2 and return to RadSrv (C) RZ


	main::LOG ("NOW START QUERY PROCESSING ...'$direction_' $cmd $query_id $service_type") if ($main::DEBUG>1);

	$bytes_in*=1;
	$bytes_out*=1;

	if( $cmd eq 'update' || $cmd eq 'finish' || $cmd eq 'fixedcalc') {
                my $ret=&common::save_session (
                $dbh,
                $query_id,
                $service_type,
                $session_begin,
                $session_long,
                $user_id,
                $src_major,
                $src_minor,
                $dst_major,
                $dst_minor,
                $bytes_in,
                $bytes_out,
                $nas_id,
                "",
                "",
                "",
                );

                if($ret!~ /OK/) {
                        main::LOG ("ERROR: can't save session") if ($main::DEBUG>0);
                        return;
                }

        } 




        my ($oper_id,$nas_type) = &common::get_oper_id($nas_id);
        if(!defined($oper_id)) {
                main::LOG ("ERROR: oper_id not found (nas_id=$nas_id)") if ($main::DEBUG>0);
                return "ERROR\t$query_id\toper_id not found (nas_id=$nas_id)\n";
        }

        my $srv=get_service($oper_id,$user_id,$session_begin);
        if(!defined($srv)) {
        	main::LOG ( "ERROR:  1 user_id not found " .
                	"(oper_id=$oper_id, user_id=$user_id, session_begin=$session_begin)") 
			if ($main::DEBUG>0);

                return "ERROR\t$query_id\tuser_id not found" .
                	"(oper_id=$oper_id, user_id=$user_id, session_begin=$session_begin)"."\n";

        }

	my $client_id = $srv->{'client_id'};
        if(!defined($client_id)) {
                main::LOG ("ERROR: client_id not found (oper_id=$oper_id, user_id=$user_id)"
			) if ($main::DEBUG>0);

                return "ERROR\t$query_id\tclient_id not found (oper_id=$oper_id, " .
			"user_id=$user_id)\n";
        }

        if(!$srv->{'date_active'}) {
                my $sql="UPDATE ${service_type}_services SET date_active=current_timestamp WHERE ".
                        " oper_id='$oper_id' AND user_id='$user_id'";

                main::LOG("SQL:\n$sql\n") if($main::DEBUG>1);

                my $rv = $dbh->do( $sql );
                if( !$rv ) {
                        main::LOG (sprintf("SQLERROR: %s", $dbh->errstr)) if ($main::DEBUG>0);
                        $dbh->rollback;
                        return ;

                }

                $srv->{'date_active'} = &common::time2str( time );
                $dbh->commit;

        }

        my $water_mark = 1 * $srv->{'water_mark'};

        my ($balance,$balance_currency_type,$options,$client_type) =
                        &common::get_client_balance($dbh,$oper_id,$client_id);

        if(!defined($balance) ) {
                main::LOG ("ERROR: can't get balance (oper_id=$oper_id, " .
                "client_id=$client_id)") if ($main::DEBUG>0);

                return "ERROR\t$query_id\tcan't get balance (oper_id=$oper_id, " .
                        "client_id=$client_id)\n";
        }

        if(!defined($balance_currency_type) ) {
                main::LOG ("ERROR: balance's currency_type not found ".
                "(oper_id=$oper_id, client_id=$client_id)") if ($main::DEBUG>0);
                return "ERROR\t$query_id\tbalance's currency_type not found ".
                        "(oper_id=$oper_id, client_id=$client_id)\n";
        }

	if ($cmd eq 'auth' || $cmd eq 'update' || $cmd eq 'finish') {
		my $enabled = $srv->{'enabled'};
        	if(!$enabled) {
                	main::LOG ("ERROR: user blocked (oper_id=$oper_id, " .
			" user_id=$user_id)") if ($main::DEBUG>0);

                	return "ERROR\t$query_id\tuser blocked (oper_id=$oper_id, " .
				"user_id=$user_id)\n";
        	}


	}


	if ($cmd eq 'auth') {
		if($srv->{ani}) {
			my $ani = $srv->{ani};
			if($src_major !~ /${ani}$/ ) {
				main::LOG ("ERROR: ani authorization failed " 	.
					"(src_addr_major=$src_major, ani=$ani )" ) 
					if ($main::DEBUG>0);

				return "ERROR\t$query_id\tani authorization failed "  .
                                        "(src_addr_major=$src_major, ani=$ani )\n";

			}	

		}

		my $srv_password = $srv->{'password'};

        	if($srv->{'password_type'} eq '0') {

			#no password;

		} elsif ($srv->{'password_type'} eq '1' ) {
                        if(length($password) == 114 ) { ### This should be considered as MS-CHAP-v2 auth. (C) RZ
                                my ($PeerChallenge, $PeerResponse, $AuthenticatorChallenge) = DecodeMSCHAP2 ( $password);
                                return "ERROR\t$query_id\tMS-CHAP-v2 authorization failed: $password"
                                   if(!CheckMSCHAP2($user_id, $srv_password, $PeerChallenge,
                                                        $PeerResponse, $AuthenticatorChallenge));
                                $MSCHAPAuthenticatorResponse =
                                        GenerateAuthenticatorResponse ($srv_password,
                                        GenerateNTResponse($AuthenticatorChallenge, $PeerChallenge, $user_id, $srv_password),
                                        $PeerChallenge, $AuthenticatorChallenge, $user_id);

                        } elsif(!($password eq $srv_password )) {
                                main::LOG ("ERROR: authorization failed " .
                                "(oper_id=$oper_id, user_id=$user_id)") if ($main::DEBUG>0);

				return "ERROR\t$query_id\tauthorization failed ".
				"(oper_id=$oper_id, user_id=$user_id)\n";
			}

		} elsif ($srv->{'password_type'} eq '2' ) {

			if(!(crypt($password, $srv_password) eq $srv_password )) {
				main::LOG ("ERROR: authorization failed (oper_id=$oper_id, ".
				"user_id=$user_id)") if ($main::DEBUG>0);

				return "ERROR\t$query_id\tauthorization failed ". 
				"(oper_id=$oper_id, user_id=$user_id)\n";
			}
			

		} else {
                	main::LOG ("ERROR: bad password_type (password_type=" . 
				$srv->{'password_type'} . ")") if ($main::DEBUG>0);
			return "ERROR\t$query_id\tbad password_type (password_type=" . 
				$srv->{'password_type'} . ")\n";
		}

                if(($balance )<= $water_mark  ) {
                        main::LOG ("ERROR: negative balance") if ($main::DEBUG>0);
                        return "ERROR\t$query_id\tnegative balance\n";
                }

	}


        my $tariff_plan = $srv->{'tariff_plan'};
	if(!defined($tariff_plan)) {
		main::LOG ("ERROR: tariff_plan not found (oper_id=$oper_id, " .
		"user_id=$user_id)") if ($main::DEBUG>0);
		return "ERROR\t$query_id\ttariff_plan not found (oper_id=$oper_id, ".
		"user_id=$user_id)\n";
	}





	my $notariffzone;
	if ($cmd eq 'auth' || $cmd eq 'update' || $cmd eq 'finish' || $cmd eq 'fixedcalc' ) {
		$bytes_out=0;
		$notariffzone = 1; 	#      
					#  -    
	}


	my @found_tariffs;


	my $amount;
	my $resource;
 	my $resource_type; 

	my $session_tariff_zone;
	my $session_direction;
	my $session_direction_descr;
	my $zone_plan;


	my $tariff_sub_plan;
	my $tariff_plan_currency_type ;

	my $tariff;
	my $tariff_unit;
	my $tariff_id;


	my $bytes=$bytes_out;
	my $update_direction=0;


	foreach my $tariff_plan_hash ( @{$tariff_plans{$oper_id}{$tariff_plan}} ) {

	     my	$tp_ref=$tariff_plan_hash;

		my $direction_ref;
		my $tariff_zone;

		$zone_plan=$tp_ref->{'zone_plan'};

		if (($cmd eq 'netflow')) {
			$direction_ref= get_direction($oper_id,$zone_plan,
				$src_major, $dst_major, $direction_) ;

			$tariff_zone=$direction_ref->{'tariff_zone'};

        		$session_direction = $direction_ref->{direction_id};
			$session_direction_descr = $direction_ref->{descr};
        		$session_tariff_zone = $tariff_zone;

			if($session_direction_descr)  {
				$update_direction=1;
			}
		}

		$tariff_sub_plan = $tp_ref->{tariff_sub_plan};
		my $calc_module=$tariff_sub_plans{$oper_id}{$tariff_plan}{$tariff_sub_plan}->{calc_module};
		my $calc_module_ref=$CFG::TARIFFMODULES->{$service_type}->{$calc_module};


		my $process_tariffsubplan =  (
			($cmd eq 'fixedcalc' && $calc_module_ref->{fixedcalc}) ||
                        (!($cmd eq 'fixedcalc') && !($calc_module_ref->{fixedcalc}) )
		); 

		if(! $process_tariffsubplan) {
			#main::LOG("DEBUG SKIP THIS TARIFF SUB PLAN");
			next;
		}; 



		my $counter;

	 	my $counter_resource_type = $calc_module_ref->{counter_unit};
		my $session_divide_by = $calc_module_ref->{session_divide_by};


		my $counter_id=$calc_module_ref->{counter_id};


		if( $counter_id ) {
				
                	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
                        localtime(common::str2time($session_begin));
                	$mon++;
                	$year += 1900;
                	my $month_begin=sprintf("%.4i_%.2i_01",$year,$mon);


			$counter_id=~ s/\{service_type\}/$service_type/;
			$counter_id=~ s/\{month_begin\}/$month_begin/;
			$counter_id=~ s/\{client_id\}/$client_id/;
			$counter_id=~ s/\{user_id\}/$user_id/;
			$counter_id=~ s/\{tariff_zone\}/$tariff_zone/;

                	$counter=common::get_counter($dbh,$oper_id,$counter_id);

                }




		

		push @found_tariffs,
		get_tariff( $oper_id,$tariff_plan,$tariff_sub_plan,$nas_id,$tariff_zone,
                $client_type,$session_begin,$counter, $notariffzone,$session_long,$bytes,
                $counter_resource_type,$session_divide_by);


        }


	my $found_len =@found_tariffs;
        if(!($found_len>0)) {
                main::LOG ("ERROR: tariff not found (oper_id=$oper_id, " .
                " tariff_plan=$tariff_plan, tariff_sub_plan=$tariff_sub_plan, " .
                " session_begin=$session_begin)") if ($main::DEBUG>0);

                return "ERROR\t$query_id\ttariff not found (oper_id=$oper_id, " .
                "tariff_plan=$tariff_plan, tariff_sub_plan=$tariff_sub_plan, ".
                "session_begin=$session_begin)\n";
        }

	my $sum_session_long_calc=0;

	foreach my $tariff_hash (@found_tariffs) {

		$sum_session_long_calc +=$tariff_hash->{session_long};

                my $tariff_ref=$tariff_hash->{tariff_ref};


		my $tariff_sub_plan = $tariff_ref->{tariff_sub_plan};
		my $tp_ref=$tariff_sub_plans{$oper_id}{$tariff_plan}{$tariff_sub_plan};

                $tariff_id= $tariff_ref->{tariff_id};
                $tariff = $tariff_ref->{tariff};

                $tariff_unit=$tp_ref->{'tariff_unit'};


		if(!defined($tariff)) {
		main::LOG ("ERROR: tariff not found (oper_id=$oper_id, " .
		" tariff_plan=$tariff_plan, tariff_sub_plan=$tariff_sub_plan, " .
		" session_begin=$session_begin)") if ($main::DEBUG>0);

		return "ERROR\t$query_id\ttariff not found (oper_id=$oper_id, " .
		"tariff_plan=$tariff_plan, tariff_sub_plan=$tariff_sub_plan, ".
		"session_begin=$session_begin)\n";
		}




		my $session_begin_calc=$tariff_hash->{session_begin};
		my $session_long_calc=$tariff_hash->{session_long};

                my $discount = get_discount ($oper_id,$client_id,$srv->{user_id},
                                $tariff_plan,$tariff_sub_plan,$session_begin_calc);

                if( defined($discount) ) {
                        my $d = $discount->{discount};
                        if ( defined($d) ) {
                               $tariff = $tariff * ( 100 - $d ) / 100 ;
                                #main::LOG ("DISCOUNT FOUND $d") ;
                        } else {
                                #main::LOG ("DISCOUNT CRUSH !!!!") ;
                        }

                } else {

                        #main::LOG ("DISCOUNT NOT FOUND $oper_id,$client_id,$user_id,$tariff_plan,$tariff_sub_plan,$session_begin_calc");

                }



                my $calc_module=$tp_ref->{calc_module};
                my $calc_module_ref=$CFG::TARIFFMODULES->{$service_type}->{$calc_module};

		my $bytes_calc = $tariff_hash->{bytes};

		
       		( $resource, $resource_type, $amount ) = 
		&{ $calc_module_ref->{'package'} . '::calc'} 
		( $session_begin_calc, $session_long_calc, $bytes_calc, $tariff, $tariff_unit, $nas_type );

        	if(!defined($amount)) {
        		main::LOG ("ERROR: can't calc (oper_id=$oper_id, " .
			"tariff_plan=$tariff_plan, session_begin=$session_begin, " . 
			"session_long=$session_long, src_major=$src_major, " .
			"dst_major=$dst_major, bytes=$bytes_out)") if ($main::DEBUG>0);

                	return "ERROR\t$query_id\tcan't calc (oper_id=$oper_id, " .
			"tariff_plan=$tariff_plan, session_begin=$session_begin," .
			"session_long=$session_long, src_major=$src_major, " .
			"dst_major=$dst_major, bytes=$bytes_out)\n";

        	}

		$tariff_plan_currency_type = $tp_ref->{'currency_type'};
		if(!defined($tariff_plan_currency_type)) {
                	main::LOG ("ERROR: tariff_plan's currency_type not found " .
			"(oper_id=$oper_id, tariff_plan=$tariff_plan , tariff_sub_plan=" . 
			$tariff_sub_plan . ")" ) if ($main::DEBUG>0);

			return "ERROR\t$query_id\ttariff_plan's currency_type not found " .
			"(oper_id=$oper_id, tariff_plan=$tariff_plan , tariff_sub_plan=" . 
			$tariff_sub_plan . ")\n";
		}


        	$amount = &common::translate_currency ( $oper_id, $tariff_plan_currency_type, 
					$balance_currency_type, $session_begin,$amount );

        	if(!defined($amount)) {
        		main::LOG ("ERROR: Can't translate currency (oper_id=$oper_id, " .
			"tariff_plan_currency_type=$tariff_plan_currency_type, " .
			"balance_currency_type=$balance_currency_type, session_begin=$session_begin," .
			" amount=$amount)") if ($main::DEBUG>0);

                	return "ERROR\t$query_id\tcan't translate currency (oper_id=$oper_id, " .
			" tariff_plan_currency_type=$tariff_plan_currency_type, " .
			" balance_currency_type=$balance_currency_type, session_begin=$session_begin, " .
			" amount=$amount)\n";
        	}

        	main::LOG("CALC RESULT: resource=$resource resource_type=$resource_type " .
		"direction=$session_direction_descr tariff_zone=$session_tariff_zone " .
		"amount=$amount\n") if($main::DEBUG>1);


        	my ($gender_h,$gender_l) = &common::get_currency_gender ($balance_currency_type);

		if(!defined($gender_h) || !defined($gender_l)) {
			main::LOG ("ERROR: Can't get currency gender " .
			"(balance_currency_type=$balance_currency_type)") if ($main::DEBUG>0);

			return "ERROR\t$query_id\tcan't get currency gender " .
			"(balance_currency_type=$balance_currency_type)\n";
		}


	 	my $update_type;
		if($cmd eq 'netflow') {
			$update_type=1;
		} else {
			$update_type=0;
		}




                my $counter_id=$calc_module_ref->{counter_id};

		#main::LOG("COUNTER res+=$resource  \n" . Dumper $tariff_hash) if($counter_id);

                if( $counter_id && $resource>0 ) {
                        my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
                        localtime(common::str2time($session_begin));
                        $mon++;
                        $year += 1900;
                        my $month_begin=sprintf("%.4i_%.2i_01",$year,$mon);


                        $counter_id=~ s/\{service_type\}/$service_type/;
                        $counter_id=~ s/\{month_begin\}/$month_begin/;
                        $counter_id=~ s/\{client_id\}/$client_id/;
                        $counter_id=~ s/\{user_id\}/$user_id/;
                        $counter_id=~ s/\{tariff_zone\}/$tariff_ref->{tariff_zone}/;



                	my $ret = common::save_counter($dbh, $oper_id,$counter_id,$resource);

                        if(!($ret eq 'OK')) {
                        	main::LOG ("ERROR: can't save counter") if ($main::DEBUG>0);
                        	return "ERROR\t$query_id\tcan't save counter\n";
                        }

                }





	

        	if ( 
			(($cmd eq 'update' || $cmd eq 'finish') && $resource_type eq 'sec')
			||
			($cmd eq 'fixedcalc' && ($resource_type eq 'month' || $resource_type eq 'day' ) )
		) {


			my $direction_descr;
			if($cmd eq 'fixedcalc') {
				$direction_descr = " ";
			};

                my	($ret,$calc_session_id) = &common::update_balance2 (
			$update_type,
                        $dbh,
                        $query_id,
                        $resource,
                        $resource_type,
                        "",
                        "",
                        $balance_currency_type,
                        $amount,
                        $user_id,
                        $oper_id,
                        $client_id,
			$tariff_plan,
			$tariff_sub_plan,
                	$direction_descr,
                	$tariff,
                	$tariff_id,
			0,
			$service_type,
			"",
			$session_begin_calc,
			$session_long_calc,

                	);

                	if(!($ret eq 'OK')) {
                        	main::LOG ("ERROR: can't update balance") if ($main::DEBUG>0);
                        	return "ERROR\t$query_id\tcan't update balance\n";
                	}


		} 




                if ($cmd eq 'netflow'  && $resource_type eq 'byte') {
                my      ($ret,$calc_session_id) = &common::update_balance2 (
                        $update_type,
                        $dbh,
                        $query_id,
                        $resource,
                        $resource_type,
                        $session_direction,
                        $session_tariff_zone,
                        $balance_currency_type,
                        $amount,
                        $user_id,
                        $oper_id,
                        $client_id,
                        $tariff_plan,
                        $tariff_sub_plan,
                        $session_direction_descr,
                        $tariff,
                        $tariff_id,
                        1,
                        $service_type,
                        $zone_plan,
                        $session_begin_calc,
                        $session_long_calc,

                        );

                        if(!($ret eq 'OK')) {
                                main::LOG ("ERROR: can't update balance") if ($main::DEBUG>0);
                                return "ERROR\t$query_id\tcan't update balance\n";
                        }

                        my $ret2=common::save_netflow_calc( $main::netflow_dbh , $real_session_id, $calc_session_id );

                        if($ret2!~ /OK/) {
                               	main::LOG ("ERROR: can't save netflow calc session") if ($main::DEBUG>0);
                               	return "ERROR\t$query_id\tcan't save netflow calc session\n";
                        }


                }



	}# foreach tariff


	################
	#     
	#


        if(($sum_session_long_calc+1)<$session_long) {

                main::LOG ("ERROR: not all tariffs found sum_session_long=$sum_session_long_calc, " .
                " session_long=$session_long " ) if ($main::DEBUG>0);

                return "ERROR\t$query_id\t not all tariffs found " .
		"sum_session_long=$sum_session_long_calc, session_long=$session_long \n";
        }






	main::LOG ("END CALCULATION GET BALANCE AND RETURN") if ($main::DEBUG>1);


        #update balance is ok. get it again.

       	($balance) = &common::get_client_balance($dbh,$oper_id,$client_id);
       	if(!defined($balance) ) {
       		main::LOG ("ERROR: can't get balance (oper_id=$oper_id, ".
			"client_id=$client_id)") if ($main::DEBUG>0);

                        return "ERROR\t$query_id\tcan't get balance (oper_id=$oper_id, " .
			"client_id=$client_id)\n";
        }

	#main::LOG ("DEBUG BALANC=$balance WATER_MARK=$water_mark\n");

        if($balance <= $water_mark  ) {
                        main::LOG ("ERROR: negative balance") if ($main::DEBUG>0);
                        return "ERROR\t$query_id\tnegative balance\n";
        }

	main::LOG ("END GET BALANCE ") if ($main::DEBUG>1);

	my $session_time_limit= $srv->{session_time_limit};
	if($session_time_limit && $session_long>$session_time_limit ) {
		main::LOG ("ERROR: session time limit") if ($main::DEBUG>0);
		return "ERROR\t$query_id\tsession time limit\n";
	}

	my $max_time = -1;

	my $features;
	if($srv->{callback}) {
		$features="CALLBACK" ;
	}

	my $preferred_ip_address;
	$preferred_ip_address=$srv->{preferred_ip_address};


	my $max_connections=$srv->{max_connections};
	my $ip_filter = $srv->{ip_filter};

	main::LOG ("NOW RETURN") if ($main::DEBUG>1);

        return "OK\t$query_id\t$balance\t$max_time\t$balance_currency_type\t\t\t$nas_type\t$features\t$preferred_ip_address\t\t\t$ip_filter\t$max_connections\t$MSCHAPAuthenticatorResponse\n";

}
#########################################################################
1;

