#!/usr/bin/perl

require "/etc/cherry/cherry.cfg";


use strict;
no strict "refs";

use FileHandle;
use DBI;
use Time::HiRes;
use Data::Dumper;

$main::DEBUG = 2;               #debug level; 0 - off; 1,2 - on

my $log_file="tariffsrv.log";



##########################################################################
sub LOG {
        my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
        my($date) = sprintf "%02d.%02d.%04d %02d:%02d:%02d", $mday, $mon+1, $year+1900, $hour, $min, $sec;

        foreach my $logstr (@_) {
                $main::LOG_DATA .= "$$\t$date\t$logstr\n";
        }

}
##########################################################################
sub LOG_FLUSH {
        if($main::LOG_DATA) {
                open(LOG_FILE, ">> $log_file") || return;
                print LOG_FILE $main::LOG_DATA;
                print $main::LOG_DATA;
                close(LOG_FILE);
                $main::LOG_DATA = "";
        }
}
##########################################################################




$main::netflow_dbh;
$main::dbh;

if(!$main::netflow_dbh) {
$main::netflow_dbh= DBI->connect("dbi:${CFG::DB_TYPE}:dbname=cherry_netflow;host=${CFG::DB_HOST}",
                    "$CFG::DB_USER",
                    "$CFG::DB_USER_PASSWORD",
                    { RaiseError => 1, AutoCommit => 0 });
}

if(!$main::dbh) {
$main::dbh= DBI->connect("dbi:${CFG::DB_TYPE}:dbname=cherry;host=${CFG::DB_HOST}",
                    "$CFG::DB_USER",
                    "$CFG::DB_USER_PASSWORD",
                    { RaiseError => 1, AutoCommit => 0 });
}


require "/usr/lib/cherry/tariffsrv/common.pl";
common::reload ($main::dbh,"common");

require "/usr/lib/cherry/tariffsrv/inet_fixed_ip.pl";
inet_fixed_ip::reload ($main::dbh,"inet_fixed_ip") ;


my $sql="SELECT session_begin,src_addr,dst_addr,bytes,nas_id,radius_session_id,session_id FROM _aaa ORDER BY session_id ";
my $sth=$main::netflow_dbh->prepare($sql);

$sth->execute;



my $i=0;
while ( my ($session_begin,$src_addr,$dst_addr,$bytes,$nas_id,$radius_session_id,$session_id) = $sth->fetchrow_array) {

	my $cmd="netflow";
	my $query_id=$radius_session_id;
	my $session_long=0;
	my $password="";
	my $src_major=$src_addr;
	my $src_minor="";
	my $dst_major=$dst_addr;
	my $dst_minor="";
	my $bytes_in=0;
	my $bytes_out=$bytes;
	my $real_session_id=$session_id;


       my  $res=&inet_fixed_ip::do_cmd (
                        $main::dbh,
                        $cmd,
                        $query_id,
                        'inet_fixed_ip',
                        $session_begin,
                        $session_long,
                        $dst_major,
                        $password,
                        $nas_id,
                        $src_major,
                        $src_minor,
                        $dst_major,
                        $dst_minor,
                        $bytes_in,
                        $bytes_out,
                        1,      # direction=1 TRAFFIC TO USER
                        $real_session_id,
                        );
	print "$res\n";

        my $res=&inet_fixed_ip::do_cmd (
                        $main::dbh,
                        $cmd,
                        $query_id,
                        'inet_fixed_ip',
                        $session_begin,
                        $session_long,
                        $src_major,
                        $password,
                        $nas_id,
                        $src_major,
                        $src_minor,
                        $dst_major,
                        $dst_minor,
                        $bytes_in,
                        $bytes_out,
                        2,      # direction=2;  TRAFFIC FROM USER
                        $real_session_id,
                        );

	print "$res\n";

	$i++;
	print "CALCULATING $i RECORDS ( $session_id )\n";



}



