#!/usr/bin/perl

$logfile = "/var/log/cherry/tariff_client.log";

@tariff_servers = ( 'inferno.t72.ru:2349', );

##############################################################################

$counter = 0;

use Socket;
use DBI;
use Time::Local;

$|=1;

$TRYING_COUNTER = 10;

OPEN_TARIFF_SERVERS();

my $counter=0;

while( <> ) {

	chomp;
	my (
                $cmd,                   # CMD
                $id,                    # "$sid@$host:time"
                $service_type,          # service type (voip_ip ... )
                $session_begin,         # session begin time
                $session_long,          # session long
                $user_id,               # user's id
                $password,              # password
                $host,                  # NAS ID
                $src_major,             # src major address
                $src_minor,             # src minor address
                $dst_major,             # dst major address
                $dst_minor,             # dst minor address
                $bytes_in,              # bytes in
                $bytes_out,             # bytes out

	) = split ("\t");

        SEND_TO_TARIFF_SERVERS(
                $cmd,                   # CMD
                $id,                    # "$sid@$host:time"
                $service_type,          # service type (voip_ip ... )
                $session_begin,         # session begin time
                $session_long,          # session long
                $user_id,               # user's id
                $password,              # password
                $host,                  # NAS ID
                $src_major,             # src major address
                $src_minor,             # src minor address
                $dst_major,             # dst major address
                $dst_minor,             # dst minor address
                $bytes_in,              # bytes in
                $bytes_out,             # bytes out

        );
	
	$counter++;


} # end of while

CLOSE_TARIFF_SERVERS();

LOG("Send to tarifsrv $counter request");


exit;

#############################################################################################
#############################################################################################
#############################################################################################

sub OPEN_TARIFF_SERVERS {


    foreach (@tariff_servers) {
        ### next if (join(" ", @tariff_sockets) =~ /$_/);

        ### print("Trying tariff server: $_\n");
        my($t_host, $t_port) = split(':'),
        $t_proto = getprotobyname('tcp');
        $t_paddr_auth = sockaddr_in($t_port, inet_aton($t_host));
        $TARIFF = "$t_host:$t_port";
        if(socket($TARIFF, PF_INET, SOCK_STREAM, $t_proto)) {
                ### print ("\tsocket allocated\n");
        } else {
                ### print("\tsocket() failed: $!\n");
                next;
        }

        if(connect($TARIFF, $t_paddr_auth) ) {
                ### print ("\tsocket connected\n");
        } else {
                ### print("\tconnect() failed: $!\n");
                close($TARIFF);
                next;
        }

	wait_for_complete($TARIFF);  ### wait for command prompt to appear, skill fscking copyritghs

	syswrite($TARIFF,"reboot_disable\n", 15);
	wait_for_complete($TARIFF);  ### wait till command completed

	push @tariff_sockets, $TARIFF;

    }

}

sub CLOSE_TARIFF_SERVERS {

    foreach (@tariff_servers) { SOCKET_REMOVE($_); }

}



sub SEND_TO_TARIFF_SERVERS {
        my $TRQ = "";
        my $TARIFF_SOCK;

        # rotate sockets



        while(1) {
        	$TARIFF_SOCK = shift @tariff_sockets;
        	push @tariff_sockets, $TARIFF_SOCK if($TARIFF_SOCK);

        	if(! $TARIFF_SOCK) {
                	LOG("No tariffication servers available, request skipped");
                	sleep(1);
			CLOSE_TARIFF_SERVERS;
			OPEN_TARIFF_SERVERS;
                	next;
        	}
        	last;
        }


        foreach (@_) { $TRQ = $TRQ.$_."\t"; }

        $TRQ = $TRQ . "\n";

        if( ($sw = syswrite($TARIFF_SOCK, $TRQ, length($TRQ))) < 0) {
                LOG("TRQ socket $TARIFF_SOCK failed! syswrite = $sw");
                SOCKET_REMOVE($TARIFF_SOCK);
                next;
        } else {
                LOG("$TRQ");
        }


        wait_for_complete($TARIFF_SOCK);

}



sub wait_for_complete {

	my $SOCK = shift @_;
	my $i=0;

	while($i<=$TRYING_COUNTER) {
        	sysread($SOCK, $junk, 1024);
        	LOG("GOT($i): $junk\n");
		last if($junk =~ />/);
		$i++;
	}

	if($i>=$TRYING_COUNTER ) {
		LOG ("ERROR: Socket timeout $SOCK");
		SOCKET_REMOVE($SOCK);
	}

}

sub SOCKET_REMOVE {
        my $sock = shift @_;
        my @new_tariff_sockets = ();
        foreach (@tariff_sockets) {
                push(@new_tariff_sockets, $_) if(!($sock eq $_));
        }
        @tariff_sockets = @new_tariff_sockets;
        close($sock);

        LOG("Socket $sock removed from ring");
}


sub LOG {
	my $msg = shift @_;
        my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
                localtime(time);

        my($date) = sprintf "$tt %02d.%02d.%04d %02d:%02d:%02d", $mday, $mon+1, $year+1900, $hour, $min, $sec;

	$msg = $date."\t".$msg;		

	open(OUT,">>$logfile");
	print OUT $msg."\n";
	print $msg."\n";
	close(OUT);
}
