#!/usr/bin/perl 
##############################################################################
#
#                    Template Processing Utility
#
##############################################################################

sub eval_ {
	my ($filename,$left_tag,$right_tag)=@_;

	open IN , $filename or die "Can't open $filename";

        my $s;
        while(<IN>) { $s.=$_; }

        my $delimeter="EOT" . rand 0xFFFFFFFF;
        $s=~s/$left_tag/\n$delimeter\n/g;
        $s=~s/$right_tag/\nprint << "$delimeter";\n/g;
        $s="print << \"$delimeter\";\n$s\n$delimeter\n";

	### debug
	#$tmp=`date '+%Y-%m-%d_%H_%M_%S'`;
	#chop $tmp;
	#$tmp="/tmp/template_$tmp";
	#open (LOG , "> $tmp") or die "Can't open debug log file";
	#print LOG $s;
	#close LOG;
	###

        eval $s;

    	die $@ if $@;
}
#################################################
sub include_ {
	my ($filename)=@_;
	eval_ $filename,$left_tag,$right_tag ;
}
#################################################
sub alarm_handler {
	print "\n";
	flush;
	alarm(10);
}
#################################################

$|=1;

use CGI::Deurl export => 'main';

#print "<SCRIPT> alert('  ') </SCRIPT>";
#exit;

$operator = $ENV{'REMOTE_USER'};


require "/etc/cherry/cherry.cfg";

require "$CFG::BASE/ucp.cfg";
require "$CFG::BASE/groups.cfg";
require "$CFG::BASE/actions.cfg";

$SIG{'ALRM'} = "alarm_handler";

alarm(10);

$left_tag='<\?';
$right_tag='\?>';

while( $tpl =~ s/\.\.\//\.\//g ) {}  # sanity check for '..' symbols
while( $language =~ s/\.\.\//\.\//g ) {}  # sanity check for '..' symbols

if( ! defined($language) ) {
   # language was not defined in CGI
   if ( defined( @operators::language{$operator} ) ) {
   	$language = @operators::language{$operator};
   } else {
   	$language = $CFG::DEFAULT_LANGUAGE;
   }
}

$dict_file     = $CFG::DICT."/$language.dict";
require "$dict_file";


$template_file = $CFG::TEMPLATES."/$tpl";
-f $template_file or die "File $template_file not exists";


if($ltag) { $left_tag=$ltag }
if($rtag) { $right_tag=$rtag }

### Checking permissions...

$act = $tpl;
$act =~ s/.*\///;

foreach $group (split(' ', @operators::group{$operator})) {
	foreach $action (split(' ', @groups::action{$group})) {

		$act = $action;
		$module = $action;
		($module,$act) = $action =~ /([a-z\_]*)_([A-Z\_]*)/ ;
		### print "Module: $module, action: $act <BR>\n";

		
		foreach $permit_file (split(' ', $actions::action{$module}->{$act} )) {
			### print "$permit_file : $module : $permit_file <BR>";
			if($template_file =~ /$module\/$permit_file/) {
				$permit_flag++;
			}
		}
	}
}

### print "<SCRIPT> alert('$permit_flag') </SCRIPT>";
#### $permit_flag++;

if(! $permit_flag) {
	print "<SCRIPT> alert('$D_PERMISSION_DENIED :: $tpl'); </SCRIPT> ";
	exit;
}

### Checking $oper_id. to meet what is listed in @operators::providers...

$permit_flag = 0 if ($oper_id);

foreach $op (split(' ', @operators::providers{$operator})) {
	if( $oper_id eq $op) { $permit_flag++; last; } 
}

#### $permit_flag++;

if( ! $permit_flag) {
	print "<SCRIPT> alert('$D_PERMISSION_DENIED_PROVIDER :: $oper_id'); </SCRIPT> ";
	exit;
}

### Eveything seems to be ok,
### Do the stuff...


include_ "$CFG::TEMPLATES/meta.tpl";
include_ $template_file;

1;
