<?
require "/usr/lib/cherry/dbaccess";
#require "$CFG::BASE/caller/config.cfg";

@allowed_providers = split ' ', $operators::providers{$operator};

$clause = join ', ', map { $dbh->quote($_) } @allowed_providers;

if($action eq 'add_period') {
	unless($from_time =~ /^(\d\d):(\d\d)$/) {
		?><SCRIPT>alert("$D_CALLER_WRONG_TIME_FORMAT"); history.back(1);</SCRIPT><?
		return;
	}
	$from_time = $1 * 3600 + $2 * 60 + $day * 86400;

	unless($till_time =~ /^(\d\d):(\d\d)$/) {
		?><SCRIPT>alert("$D_CALLER_WRONG_TIME_FORMAT"); history.back(1);</SCRIPT><?
		return;
	}
	$till_time = $1 * 3600 + $2 * 60 + $day * 86400;

	if(not length $add_interval or $add_interval =~ /\D/ or $add_interval <= 0) {
		?><SCRIPT>alert("$D_CALLER_WRONG_INTERVAL"); history.back(1);</SCRIPT><?
		return;
	}
}

if($action eq 'delete_period' and $id !~ /\D/) {
	$dbh->do("DELETE FROM caller_periods WHERE id = $id AND plan_id IN (SELECT id FROM caller_plans WHERE oper_id IN ($clause))");
}

if($action eq 'add_period' and $oper !~ /\W/ and $client_type !~ /\W/) {
	($plan_id) = $dbh->selectrow_array("SELECT id FROM caller_plans WHERE oper_id = '$oper' AND name = '_SYSTEM_PLAN_FOR_${client_type}'");

	if(defined $plan_id) {
		my $sth = $dbh->prepare("SELECT id, from_time, till_time FROM caller_periods WHERE plan_id = $plan_id AND from_time < $till_time AND till_time > $from_time");
		$sth->execute;
		while(my($id, $f_time, $t_time) = $sth->fetchrow_array) {
			$from_time = $f_time if $f_time < $from_time;
			$till_time = $t_time if $t_time > $till_time;
			$dbh->do("DELETE FROM caller_periods WHERE id = $id");
		}

		$dbh->do("INSERT INTO caller_periods (id, plan_id, from_time, till_time, interval) VALUES (nextval('caller_periods_id_seq'), $plan_id, $from_time, $till_time, $add_interval * 60)");
	}
}

if(defined $tries and $tries !~ /\D/ and $oper !~ /\W/ and $client_type !~ /\W/) {
	($plan_id) = $dbh->selectrow_array("SELECT id FROM caller_plans WHERE oper_id = '$oper' AND name = '_SYSTEM_PLAN_FOR_${client_type}'");

	if(defined $plan_id) {
		$dbh->do("UPDATE caller_plans SET tries = $tries WHERE id = $plan_id");
	}
}

?>
<BODY>
<TABLE class="page_h" >
<TR><TD> $D_CALLER_CALLGEN_SETUP </TD></TR>
</TABLE>
<?

my $sth = $dbh->prepare("SELECT oper_id, name FROM base_providers WHERE oper_id IN ($clause) ORDER BY name");
$sth->execute;

while(($oper_id, $name) = $sth->fetchrow_array) {
?>
<TABLE class=page_h>
<TR><TD> $D_PROVIDER: $name</TD></TR>
</TABLE>
<!-- <LI>    <INPUT type=checkbox> -->
<!-- <LI>     <INPUT type=text size=2 maxlength=2> -->
<?

@types = @{ $dbh->selectcol_arrayref("SELECT DISTINCT(base_clients.client_type) FROM base_clients JOIN telephone_services USING (oper_id, client_id) WHERE oper_id = '$oper_id'") };

$types_clause = join ', ', map { $dbh->quote($_) } @types;

my $sth = $dbh->prepare("SELECT client_type, descr FROM base_client_types WHERE oper_id = '$oper_id' AND client_type IN ($types_clause) ORDER BY client_type");

$sth->execute;

while(($client_type, $descr) = $sth->fetchrow_array) {
	($plan_id, $tries) = $dbh->selectrow_array("SELECT id, tries FROM caller_plans WHERE oper_id = '$oper_id' AND name = '_SYSTEM_PLAN_FOR_$client_type'");

	unless(defined $plan_id) {
		$dbh->do("INSERT INTO caller_plans (id, name, tries, oper_id) VALUES (nextval('caller_plans_id_seq'), '_SYSTEM_PLAN_FOR_$client_type', 100, '$oper_id')");
		($plan_id) = $dbh->selectrow_array("SELECT currval('caller_plans_id_seq')");
		$tries = 100;
	}

?>
<TABLE class=page_h>
<TR><TD> $D_CLIENT: $descr </TD></TR>
</TABLE>
<LI> $D_CALLER_PLAN </LI>
<TABLE border=1>
<?


$day = 0;
foreach(qw(      )) {

$start = $day * 86400;
$end = $start + 86400;

my $sth = $dbh->prepare("SELECT id, from_time, till_time, interval FROM caller_periods WHERE plan_id = $plan_id AND from_time < $end AND till_time > $start ORDER BY from_time ASC");

$sth->execute;

@periods = ();

while(($id, $from, $till, $interval) = $sth->fetchrow_array) {
	$f_time = $from - $start;
	$f_time = 0 if $f_time < 0;
	$t_time = $till - $start;
	$t_time = 86399 if $t_time > 86399;
	$f_hour = int($f_time / 3600);
	$f_min = int(($f_time - $f_hour * 3600) / 60);
	$t_hour = int($t_time / 3600);
	$t_min = int(($t_time - $t_hour * 3600) / 60);
	$i_min = int($interval / 60);

	push @periods, sprintf("[<A href=\"template.cgi?tpl=caller/setup.tpl&action=delete_period&id=%d\">x</A>] %02d:%02d - %02d:%02d (%d )", $id, $f_hour, $f_min, $t_hour, $t_min, $i_min);
}

$string = join ', ', @periods;
?>
<TR>
<TD>$_:</TD>
<TD>$string</TD>
<TD>
<FORM action=template.cgi>
<INPUT type=hidden name=tpl value="caller/setup.tpl">
<INPUT type=hidden name=oper value="$oper_id">
<INPUT type=hidden name=client_type value="$client_type">
<INPUT type=hidden name=action value="add_period">
<INPUT type=hidden name=day value="$day">
<INPUT size=5 maxlength=5 name="from_time"> - <INPUT size=5 maxlength=5 name="till_time"> $D_CALLER_INTERVAL <INPUT type=text size=2 maxlength=2 name="add_interval"> $D_CALLER_MINUTES <INPUT type=submit value="$D_ADD">
</FORM>
</TD>
</TR><?

$day++;
}

?>
</TABLE>
<FORM action=template.cgi>
<INPUT type=hidden name=tpl value="caller/setup.tpl">
<INPUT type=hidden name=oper value="$oper_id">
<INPUT type=hidden name=client_type value="$client_type">
<LI> $D_CALLER_TRIES <INPUT name="tries" type=text size=3 maxlength=3 value="$tries"> <INPUT type="submit" value="$D_CHANGE">
</FORM>
<BR>
<BR>
<?
}
}

?></BODY>
